#include "extdll.h"
#include "enginecallback.h"
#include "util.h"
#include "cbase.h"
#include "player.h"
#include "weapons.h"
#include "entity_state.h"
#include "dll.h"
#include "engine.h"

#include "neotf.h"

int precached_models[256];
int precached_sounds[256];

airstrike_t AirStrike[4];

enttimes_t EntTimes[NTF_MAX_ENTS];

entinfo_t EntInfo[NTF_MAX_ENTS];

glyph_t Glyph[MAX_GLYPHS];

beacon_t Beacon[NTF_MAX_BEACONS];

modcmd_t ModCmd;

int GlyphCount;

int BeaconCount;

int Features;

char NTFVersion[32];

float NextCvarCheck;

int TeamAlly[4];

cvar_t ntf_logengmsg = {"ntf_logengmsg","0"};

cvar_t ntf_feature_spychat = {"ntf_feature_spychat","1"};
cvar_t ntf_feature_radar = {"ntf_feature_radar","1"};
cvar_t ntf_feature_glyphs = {"ntf_feature_glyphs","1"};
cvar_t ntf_feature_flashgren = {"ntf_feature_flashgren","1"};
cvar_t ntf_feature_noplayerscores = {"ntf_feature_noplayerscores", "0"};
cvar_t ntf_feature_sgcamera = {"ntf_feature_sgcamera", "1"};
cvar_t ntf_feature_laserrocket = {"ntf_feature_laserrocket", "1"};
cvar_t ntf_feature_aquaspy = {"ntf_feature_aquaspy", "1"};
cvar_t ntf_feature_antimissile = {"ntf_feature_antimissile", "1"};
cvar_t ntf_feature_devmode = {"ntf_feature_devmode", "0"};
cvar_t ntf_feature_multigun = {"ntf_feature_multigun", "1"};
cvar_t ntf_feature_flamegun = {"ntf_feature_flamegun", "1"};
cvar_t ntf_feature_teslacoil = {"ntf_feature_teslacoil", "1"};
cvar_t ntf_feature_location = {"ntf_feature_location", "1"};
cvar_t ntf_feature_meddisp = {"ntf_feature_meddisp", "1"};
cvar_t ntf_feature_airstrike = {"ntf_feature_airstrike", "1"};
cvar_t ntf_feature_grenlaunch = {"ntf_feature_grenlaunch", "1"};
cvar_t ntf_feature_rocklaunch = {"ntf_feature_rocklaunch", "1"};

cvar_t ntf_feature_sillyzone = {"ntf_feature_sillyzone", "0"};
cvar_t ntf_feature_custommodels = {"ntf_feature_custommodels", "0"};

cvar_t ntf_flashgren_hurt_team = {"ntf_flashgren_hurt_team", "0"};

void NeoTFGameDLLInit()
{
	sprintf(NTFVersion, "1.1 rev 5");
	CVAR_REGISTER(&ntf_logengmsg);
	CVAR_REGISTER(&ntf_feature_spychat);
	CVAR_REGISTER(&ntf_feature_radar);
	CVAR_REGISTER(&ntf_feature_glyphs);
	CVAR_REGISTER(&ntf_feature_flashgren);
	CVAR_REGISTER(&ntf_feature_noplayerscores);
	CVAR_REGISTER(&ntf_feature_sgcamera);
	CVAR_REGISTER(&ntf_feature_laserrocket);
	CVAR_REGISTER(&ntf_feature_aquaspy);
	CVAR_REGISTER(&ntf_feature_antimissile);
	CVAR_REGISTER(&ntf_feature_devmode);
	CVAR_REGISTER(&ntf_feature_multigun);
	CVAR_REGISTER(&ntf_feature_flamegun);
	CVAR_REGISTER(&ntf_feature_teslacoil);
	CVAR_REGISTER(&ntf_feature_location);
	CVAR_REGISTER(&ntf_feature_meddisp);
	CVAR_REGISTER(&ntf_feature_airstrike);
	CVAR_REGISTER(&ntf_feature_grenlaunch);
	CVAR_REGISTER(&ntf_feature_rocklaunch);

   	CVAR_REGISTER(&ntf_feature_sillyzone);
   	CVAR_REGISTER(&ntf_feature_custommodels);

    CVAR_REGISTER(&ntf_flashgren_hurt_team);

    GlyphCount = 0;
    BeaconCount = 0;
}

int NeoTFPlayerPreThink(edict_t *pEntity)
{
	// Don't do weird shit to non connected players
    if(FStrEq(STRING(pEntity->v.netname),"") || (!FStrEq(STRING(pEntity->v.classname),"player")))
		return 0;

	if(pEntity->v.deadflag)
    {
    	if(EntInfo[ENTINDEX(pEntity)].SGCamOn)
        {
        	NeoTFDeactivateRemoteCamera(pEntity);
        }
        /* Faking player death stuff that didn't work well
        if(pEntity->v.deadflag == DEAD_DYING)
        {
        //pEntity->v.gaitsequence = 0;
	    pEntity->v.frame = 0;
    	pEntity->v.sequence = LookupActivity(GET_MODEL_PTR(pEntity), VARS(pEntity), ACT_DIESIMPLE);
	    pEntity->v.animtime = gpGlobals->time;
	    pEntity->v.framerate = 1;
	    pEntity->v.effects |= EF_NOINTERP;
        }
        */
    /* Ditto here
	float flForward;

	if (FBitSet(pEntity->v.flags, FL_ONGROUND))
	{
		flForward = pEntity->v.velocity.Length() - 20;
		if (flForward <= 0)
			pEntity->v.velocity = g_vecZero;
		else
			pEntity->v.velocity = flForward * pEntity->v.velocity.Normalize();
	}
    */

	    EntTimes[ENTINDEX(pEntity)].LastGlyph = gpGlobals->time;
	    EntTimes[ENTINDEX(pEntity)].LastRadar = gpGlobals->time;
	    EntTimes[ENTINDEX(pEntity)].SpawnTime = gpGlobals->time;
	    EntTimes[ENTINDEX(pEntity)].LastSayEnemy = gpGlobals->time;
	    EntTimes[ENTINDEX(pEntity)].LastAquaJet = gpGlobals->time;
	    EntTimes[ENTINDEX(pEntity)].LastLaserRocket = 0;
	    EntTimes[ENTINDEX(pEntity)].DieTime = 0;
	    EntTimes[ENTINDEX(pEntity)].EventTime = 0;

	    EntInfo[ENTINDEX(pEntity)].DoneRespawnReset = 0;
        EntInfo[ENTINDEX(pEntity)].SGCamOn = 0;
        EntInfo[ENTINDEX(pEntity)].AquaJetOn = 0;
    }

    // Eliminate player's score if necessary

    if(Features & FEAT_NOPLAYERSCORES)
    {
    	pEntity->v.frags = 0;
    }

   	// waterlevel 0 - not in water
	// waterlevel 1 - feet in water
	// waterlevel 2 - waist in water
	// waterlevel 3 - head in water

    // Stop spies drowning

    if((Features & FEAT_AQUASPY) && (pEntity->v.playerclass==CLASS_SPY) && (pEntity->v.waterlevel >= 2))
    {
    	pEntity->v.air_finished = gpGlobals->time + 1;
        /* Spy's "aquajet" speedburst in water -- removed due to problems with client side prediction of velocity changes
        if(EntInfo[ENTINDEX(pEntity)].AquaJetOn && ((gpGlobals->time - EntTimes[ENTINDEX(pEntity)].LastAquaJet) > 1))
        {
		 	EMIT_SOUND(pEntity, CHAN_ITEM, "doors/doormove2.wav", 1, ATTN_NORM);
        	UTIL_MakeVectors(pEntity->v.v_angle);
        	pEntity->v.velocity = pEntity->v.velocity + gpGlobals->v_forward * (AQUAJET_SPEED);
            if(pEntity->v.velocity.Length() > AQUAJET_SPEED)
	            pEntity->v.velocity = pEntity->v.velocity.Normalize() * AQUAJET_SPEED;
            EntTimes[ENTINDEX(pEntity)].LastAquaJet = gpGlobals->time;
            // Bubble effect
            if(1)
            {
				float flHeight = UTIL_WaterLevel( pEntity->v.origin,  pEntity->v.origin.z, pEntity->v.origin.z + 1024 );
				flHeight = flHeight - pEntity->v.origin.z;
				MESSAGE_BEGIN( MSG_PAS, SVC_TEMPENTITY, pEntity->v.origin );
					WRITE_BYTE( TE_BUBBLES );
					WRITE_COORD( pEntity->v.origin.x );	// mins
					WRITE_COORD( pEntity->v.origin.y );
					WRITE_COORD( pEntity->v.origin.z );
					WRITE_COORD( pEntity->v.origin.x );	// maxz
					WRITE_COORD( pEntity->v.origin.y );
					WRITE_COORD( pEntity->v.origin.z );
					WRITE_COORD( flHeight );			// height
					WRITE_SHORT( precached_models[4] );
					WRITE_BYTE( 10 ); // count
					WRITE_COORD( 8 ); // speed
				MESSAGE_END();
            }
        }
        */
    }

    // Check for grens going off in hand and also make them be thrown when the player dies
    if(EntInfo[ENTINDEX(pEntity)].Primed.FlashGren && (pEntity->v.deadflag || (gpGlobals->time >= EntInfo[ENTINDEX(pEntity)].Primed.FlashGren + 4)))
    {
		edict_t *pFlash;
    	UTIL_MakeVectors(pEntity->v.v_angle);
    	pFlash = CREATE_NAMED_ENTITY(MAKE_STRING("info_target"));
    	DispatchSpawn(pFlash);
    	pFlash->v.origin = pEntity->v.origin;
    	pFlash->v.owner = pEntity;
    	pFlash->v.angles = Vector(0, pEntity->v.v_angle.y, 0);
    	pFlash->v.velocity = pEntity->v.deadflag ? Vector(0, 0, 32) : pEntity->v.velocity + gpGlobals->v_forward*400 + Vector(0, 0, 32);
        pFlash->v.takedamage = DAMAGE_NO;
        pFlash->v.health = 1;
        pFlash->v.movetype = MOVETYPE_BOUNCE;
        pFlash->v.nextthink = gpGlobals->time;
        pFlash->v.gravity = 0.5;
        pFlash->v.friction = 0.8;
        pFlash->v.solid = SOLID_BBOX;
    	SET_MODEL(pFlash, "models/conc_grenade.mdl");
    	UTIL_SetSize(VARS(pFlash), Vector(0, 0, 0), Vector(0, 0, 0));
    	pFlash->v.classname = MAKE_STRING("ntf_flashgren");
        EntTimes[ENTINDEX(pFlash)].EventTime = EntInfo[ENTINDEX(pEntity)].Primed.FlashGren + 4;
        EntInfo[ENTINDEX(pEntity)].Primed.FlashGren = 0;
        MESSAGE_BEGIN(MSG_ONE, 79, NULL, pEntity);
			WRITE_BYTE(0);
			WRITE_CHAR(100);
			WRITE_CHAR(95);
			WRITE_STRING("concussiongrenade");
			WRITE_BYTE(255);
			WRITE_BYTE(160);
			WRITE_BYTE(0);
        MESSAGE_END();
    }

	return 0;
}

int NeoTFPlayerPostThink(edict_t *pEntity)
{
	if(!pEntity->v.deadflag)
    {
    	if(!EntInfo[ENTINDEX(pEntity)].DoneRespawnReset)
	    {
        	if(Features & FEAT_FLASHGREN)
            {
			    EntInfo[ENTINDEX(pEntity)].Used.FlashGren = 0;
                EntInfo[ENTINDEX(pEntity)].Used.LaserRocket = 0;
				MESSAGE_BEGIN(MSG_ONE, 72, NULL, pEntity);
					WRITE_BYTE(1);
					WRITE_BYTE(FLASHGREN_AMMO - EntInfo[ENTINDEX(pEntity)].Used.FlashGren);
				MESSAGE_END();
            }

	        EntInfo[ENTINDEX(pEntity)].DoneRespawnReset = 1;
        }
    }

	return 0;
}

int NeoTFDispatchKeyValue(edict_t *pEntity, KeyValueData *pkvd)
{
	if(FStrEq(STRING(pEntity->v.classname), "info_tfdetect"))
	{
    	if(FStrEq(pkvd->szKeyName, "team1_allies"))
    		TeamAlly[0] = atoi(pkvd->szValue);
    	if(FStrEq(pkvd->szKeyName, "team2_allies"))
    		TeamAlly[1] = atoi(pkvd->szValue);
    	if(FStrEq(pkvd->szKeyName, "team3_allies"))
    		TeamAlly[2] = atoi(pkvd->szValue);
    	if(FStrEq(pkvd->szKeyName, "team4_allies"))
    		TeamAlly[3] = atoi(pkvd->szValue);
	}
    return 0;
}

int NeoTFDispatchThink(edict_t *pEntity)
{
	if(FStrEq(STRING(pEntity->v.classname), "ntf_flashgren"))
    {
    	NeoTFFlashThink(pEntity);
        return 1;
    }

    if(FStrEq(STRING(pEntity->v.classname), "ntf_amlauncher"))
    {
    	return NeoTFAntiMissileLauncherThink(pEntity);
    }

    if(FStrEq(STRING(pEntity->v.classname), "ntf_amm"))
    {
    	return NeoTFAMMThink(pEntity);
    }

    if(FStrEq(STRING(pEntity->v.classname), "ntf_multigun"))
    {
    	return NeoTFMultigunThink(pEntity);
    }

    if(FStrEq(STRING(pEntity->v.classname), "ntf_flamegun"))
    {
    	return NeoTFFlamegunThink(pEntity);
    }

    if(FStrEq(STRING(pEntity->v.classname), "ntf_teslacoil"))
    {
    	return NeoTFTeslaCoilThink(pEntity);
    }

    if(FStrEq(STRING(pEntity->v.classname), "ntf_meddisp"))
    {
    	return NeoTFMedDispThink(pEntity);
    }

    if(FStrEq(STRING(pEntity->v.classname), "ntf_airstrike"))
    {
    	return NeoTFAirStrikeThink(pEntity);
    }

    if(FStrEq(STRING(pEntity->v.classname), "ntf_airstrike_missile"))
    {
    	return NeoTFAirStrikeMissileThink(pEntity);
    }

    if(FStrEq(STRING(pEntity->v.classname), "ntf_grenlauncher"))
    {
    	return NeoTFGrenLaunchThink(pEntity);
    }

    if(FStrEq(STRING(pEntity->v.classname), "ntf_rocklauncher"))
    {
    	return NeoTFRockLaunchThink(pEntity);
    }

    if(FStrEq(STRING(pEntity->v.classname), "ntf_lrlauncher"))
    {
    	return NeoTFLRLaunchThink(pEntity);
    }

    if(FStrEq(STRING(pEntity->v.classname), "ntf_camera"))
    {
    	// Set camera's angles to sentry's
    	if(FStrEq(STRING(pEntity->v.euser1->v.classname), "building_sentrygun"))
        {
	    	pEntity->v.angles.x = 230 + (pEntity->v.euser1->v.controller[1]); //*360)/256;
	        pEntity->v.angles.y = pEntity->v.euser1->v.angles.y + (pEntity->v.euser1->v.controller[0]*360)/256;
	        pEntity->v.angles.z = 0;
            pEntity->v.origin = pEntity->v.euser1->v.origin + Vector(0, 0, 16);
            pEntity->v.velocity = pEntity->v.euser1->v.velocity;
           	if (pEntity->v.angles.y >= 360)
				pEntity->v.angles.y -= 360;
			if (pEntity->v.angles.y < 0)
				pEntity->v.angles.y += 360;

        }

        pEntity->v.nextthink = gpGlobals->time + 0.1;
        return 1;
    }
    //For the fake player death method
    /*
    if(FStrEq(STRING(pEntity->v.classname), "ntf_body"))
    {
    	if((pEntity->v.fuser1) && (gpGlobals->time >= pEntity->v.fuser1))
        	pEntity->v.flags |= FL_KILLME;
        return 0;
    }
    */

    if(FStrEq(STRING(pEntity->v.classname), "ntf_laserrocket"))
    {
    	if(pEntity->v.euser1->free) return 0;
        if((pEntity->v.origin - pEntity->v.euser1->v.origin).Length() < 64) return 0;
    	pEntity->v.velocity = pEntity->v.velocity * 0.85 + (pEntity->v.euser1->v.origin - pEntity->v.origin).Normalize() * 128;
        if(pEntity->v.velocity.Length() > 1600)
        	pEntity->v.velocity = 1600 * pEntity->v.velocity.Normalize();
        pEntity->v.nextthink = gpGlobals->time + 0.1;

        // Only let it think when it should blow up
        if(pEntity->v.fuser1 < gpGlobals->time)
        	return 0;
        else
        	return 1;
    }
	return 0;
}

void NeoTFFlashThink(edict_t *pEntity)
{
	int counter;
    edict_t *pTemp;
    CBaseEntity *pCEntity;
    KeyValueData *pkvd;
    
    	// Do effects here
        if(gpGlobals->time >= EntTimes[ENTINDEX(pEntity)].EventTime)
        {
        	EMIT_SOUND(pEntity, CHAN_VOICE, "debris/beamstart15.wav", 1, ATTN_NORM);
        	for(counter=1; counter <= gpGlobals->maxClients; counter++)
            {
            	pCEntity = UTIL_PlayerByIndex(counter);
                if(pCEntity != NULL)
                {
	            	if(FVisible(pEntity->v.origin, ENT(pCEntity->pev)) && ((pEntity->v.origin - pCEntity->pev->origin).Length() < FLASHGREN_RANGE) && ((ENTINDEX(ENT(pCEntity->pev))==ENTINDEX(pEntity->v.owner))||(pCEntity->pev->team!=pEntity->v.owner->v.team && !(TeamAlly[pEntity->v.owner->v.team-1] & (1<<pCEntity->pev->team))) || CVAR_GET_FLOAT("ntf_flashgren_hurt_team")))
	                {
                    	// int alpha = (pow(FLASHGREN_RANGE - (pEntity->v.origin - pCEntity->pev->origin).Length(), 2)*64)/pow(FLASHGREN_RANGE, 2) + 224;
                        int alpha = 255; // make it always fade to white -- people said it wasn't powerful enough before
	                    pCEntity->ScreenFade(Vector(255, 255, 255), alpha, 5, 3, FFADE_IN);
	                }
	            }
            }
    		pEntity->v.flags |= FL_KILLME;
        }
        else
        {
        	if(pEntity->v.flags & FL_ONGROUND)
            {
            	pEntity->v.velocity = pEntity->v.velocity * 0.5;
            }
            if(pEntity->v.waterlevel)
            {
            	pEntity->v.velocity = pEntity->v.velocity * 0.5;
            }
        }
        pEntity->v.nextthink = gpGlobals->time + 0.1;
}

int NeoTFDispatchUse(edict_t *pEntity, edict_t *pOther)
{
	/*
	 ALERT(at_console, "> %s used %s.\n", STRING(pOther->v.classname), STRING(pEntity->v.classname));
    return 0;
    */
}

int NeoTFDispatchTouch(edict_t *pEntity, edict_t *pOther)
{
	// Med upgrading dispenser
    if((Features & FEAT_MEDDISP) && FStrEq(STRING(pEntity->v.classname), "building_dispenser") &&  FStrEq(STRING(pOther->v.classname), "player") && (pOther->v.playerclass == CLASS_MEDIC)) // NOTE: Change to CLASS_MEDIC
    {
    	NeoTFMedDispBuild(pOther, pEntity);
    }

	// Pyro upgrading multigun to flamegun ***REMOVED***
    /*
    if((Features & FEAT_FLAMEGUN) && FStrEq(STRING(pEntity->v.classname), "ntf_multigun") && FStrEq(STRING(pOther->v.classname), "player") && (pOther->v.playerclass == CLASS_ENGINEER) && (pEntity->v.team == pOther->v.team)) // NOTE: Change to CLASS_PYRO
    {
    	NeoTFFlamegunBuild(pOther, pEntity);
    }
    */

    // Spy upgrading multigun to tesla coil
    if((Features & FEAT_TESLACOIL) && FStrEq(STRING(pEntity->v.classname), "ntf_multigun") && FStrEq(STRING(pOther->v.classname), "player") && ((pOther->v.playerclass == CLASS_SCOUT) || (pOther->v.playerclass == CLASS_SPY)) && (pEntity->v.team == pOther->v.team)) // NOTE: Change to CLASS_SCOUT
    {
    	NeoTFTeslaCoilBuild(pOther, pEntity);
    }

    if((Features & FEAT_GRENLAUNCH) && FStrEq(STRING(pEntity->v.classname), "ntf_multigun") && FStrEq(STRING(pOther->v.classname), "player") && ((pOther->v.playerclass == CLASS_DEMOMAN) || (pOther->v.playerclass == CLASS_HWGUY)) && (pEntity->v.team == pOther->v.team)) // NOTE: Change to CLASS_DEMOMAN
    {
    	NeoTFGrenLaunchBuild(pOther, pEntity);
    }

    if((Features & FEAT_ROCKLAUNCH) && FStrEq(STRING(pEntity->v.classname), "ntf_multigun") && FStrEq(STRING(pOther->v.classname), "player") && ((pOther->v.playerclass == CLASS_SOLDIER) || (pOther->v.playerclass == CLASS_PYRO)) && (pEntity->v.team == pOther->v.team)) // NOTE: Change to CLASS_SOLDIER
    {
    	NeoTFRockLaunchBuild(pOther, pEntity);
    }

    if((Features & FEAT_LRLAUNCH) && FStrEq(STRING(pEntity->v.classname), "ntf_multigun") && FStrEq(STRING(pOther->v.classname), "player") && (pOther->v.playerclass == CLASS_ENGINEER) && (pEntity->v.team == pOther->v.team)) // NOTE: Change to CLASS_SNIPER
    {
    	NeoTFLRLaunchBuild(pOther, pEntity);
    }

	if(FStrEq(STRING(pEntity->v.classname), "ntf_flashgren"))
    {
    	if(abs(pEntity->v.velocity.z) > 32)
        {
        	switch ( RANDOM_LONG( 0, 2 ) )
          		{
        			case 0:	EMIT_SOUND(pEntity, CHAN_VOICE, "weapons/grenade_hit1.wav", 0.5, ATTN_NORM);	break;
                	case 1:	EMIT_SOUND(pEntity, CHAN_VOICE, "weapons/grenade_hit2.wav", 0.5, ATTN_NORM);	break;
                	case 2:	EMIT_SOUND(pEntity, CHAN_VOICE, "weapons/grenade_hit3.wav", 0.5, ATTN_NORM);	break;
            	}
		}
    	return 1;
    }

    if((FStrEq(STRING(pEntity->v.classname), "ntf_airstrike_missile") || (FStrEq(STRING(pEntity->v.classname), "ntf_gl_grenade"))) && !FStrEq(STRING(pOther->v.classname), "ntf_grenlauncher") && (pEntity->v.movetype != MOVETYPE_NOCLIP))
    {
    	pEntity->v.velocity = Vector(0,0,0);
    	pEntity->v.nextthink = gpGlobals->time;
        if(FStrEq(STRING(pEntity->v.classname), "ntf_gl_grenade"))
	        pEntity->v.owner = pEntity->v.owner->v.euser1; // Reset teh real owner
    }

    if(FStrEq(STRING(pEntity->v.classname), "ntf_rocket") && !FStrEq(STRING(pOther->v.classname), "ntf_rocklauncher"))
    {
    	pEntity->v.velocity = Vector(0,0,0);
        pEntity->v.owner = pEntity->v.owner->v.euser1; // Reset teh real owner
    	pEntity->v.nextthink = gpGlobals->time;
    }
	return 0;
}

int NeoTFDispatchBlocked(edict_t *pEntity, edict_t *pOther)
{
	return 0;
}


int NeoTFClientCommand(edict_t *pEntity)
{
	CBaseEntity *pCEntity;
    Vector tVector1, tVector2, tVector3;
    TraceResult tr;
    int counter;

    // Log commands to console if in dev mode
    if(Features & FEAT_DEVMODE)
    	ALERT(at_console, "{NeoTF}<%s><%d>:<%s><%s>\n", STRING(pEntity->v.netname), ENTINDEX(pEntity), Cmd_Argv(0), Cmd_Args());

    pCEntity = CBaseEntity::Instance(pEntity);

    if(FStrEq(STRING(pEntity->v.netname),"") || (!FStrEq(STRING(pEntity->v.classname),"player")))
		return 0;

    if(Features & FEAT_SPYCHAT) NeoTFSpyChat(pEntity);
    if(Features & FEAT_RADAR) NeoTFRadar(pEntity);
    if(Features & FEAT_GLYPHS) NeoTFGlyph(pEntity);
    if(Features & FEAT_FLASHGREN) NeoTFFlashGren(pEntity);
    if((Features & FEAT_SGCAMERA) && pEntity->v.playerclass == CLASS_ENGINEER) NeoTFSGCamera(pEntity);
    if((Features & FEAT_LASERROCKET) && pEntity->v.playerclass == CLASS_SNIPER) NeoTFLaserRocket(pEntity);
//    if((Features & FEAT_AQUASPY) && pEntity->v.playerclass == CLASS_SPY) NeoTFAquaSpy(pEntity);
    if((Features & FEAT_ANTIMISSILE) && pEntity->v.playerclass == CLASS_SNIPER) NeoTFAntiMissile(pEntity);
    if((Features & FEAT_MULTIGUN) && pEntity->v.playerclass == CLASS_ENGINEER) NeoTFMultigunBuild(pEntity);
    if((Features & FEAT_AIRSTRIKE) && ((pEntity->v.playerclass == CLASS_SCOUT) || (pEntity->v.playerclass == CLASS_SPY))) NeoTFCallAirStrike(pEntity);
    if(Features & FEAT_LOCATION)
    	if(NeoTFLocation(pEntity))
        	return 1;

    // Stop players using gren1 when flash is primed
    // We should also stop use of flash when gren1 is primed but that's too much work and would be unreliable
    if(EntInfo[ENTINDEX(pEntity)].Primed.FlashGren)
    {
    	if(FStrEq(Cmd_Argv(0), "+gren1") || FStrEq(Cmd_Argv(0), "primeone") || FStrEq(Cmd_Argv(0), "-gren1"))
        	return 1;
    }

    if(FStrEq(Cmd_Argv(0), "entinfo") && (Features & FEAT_DEVMODE))
    {
    	char tString[8192];
        CBaseEntity *pCMe;
        pCMe = CBaseEntity::Instance(pEntity);
    	pCEntity = NULL;
    	while(pCEntity = UTIL_FindEntityByClassname(pCEntity, Cmd_Argv(1)))
        {
        	sprintf(tString, "{NeoTF} <%s ent index: %d> <owner ent index: %d> <controller: %d/%d/%d/%d>\n", STRING(pCEntity->pev->classname), ENTINDEX(ENT(pCEntity->pev)), pCEntity->pev->owner ? ENTINDEX(pCEntity->pev->owner) : -1, pCEntity->pev->controller[0], pCEntity->pev->controller[1], pCEntity->pev->controller[2], pCEntity->pev->controller[3]);
            pCMe->PrintTalk(tString);
            sprintf(tString, "{NeoTF} <iuser: %d/%d/%d/%d> <fuser: %f/%f/%f/%f>\n", pCEntity->pev->iuser1, pCEntity->pev->iuser2, pCEntity->pev->iuser3, pCEntity->pev->iuser4, pCEntity->pev->fuser1, pCEntity->pev->fuser2, pCEntity->pev->fuser3, pCEntity->pev->fuser4);
            pCMe->PrintTalk(tString);
            sprintf(tString, "{NeoTF} <euser: %d/%d/%d/%d> <chain: %d>\n", pCEntity->pev->euser1 ? ENTINDEX(pCEntity->pev->euser1) : -1, pCEntity->pev->euser2 ? ENTINDEX(pCEntity->pev->euser2) : -1, pCEntity->pev->euser3 ? ENTINDEX(pCEntity->pev->euser3) : -1, pCEntity->pev->euser4 ? ENTINDEX(pCEntity->pev->euser4) : -1, pCEntity->pev->chain ? ENTINDEX(pCEntity->pev->chain) : -1);
            pCMe->PrintTalk(tString);
            sprintf(tString, "{NeoTF} <team: %d> <colormap: %d> <health: %f> <dmg: %f> <armorvalue: %f>\n", pCEntity->pev->team, pCEntity->pev->colormap, pCEntity->pev->health, pCEntity->pev->dmg, pCEntity->pev->armorvalue);
            pCMe->PrintTalk(tString);
            sprintf(tString, "{NeoTF} <angles: (%f, %f, %f)> <origin: (%f, %f, %f)>\n", pCEntity->pev->angles.x, pCEntity->pev->angles.y, pCEntity->pev->angles.z, pCEntity->pev->origin.x, pCEntity->pev->origin.y, pCEntity->pev->origin.z);
            pCMe->PrintTalk(tString);
            sprintf(tString, "{NeoTF} <model: %s> <skin: %d> <sequence: %d>\n", STRING(pCEntity->pev->model), pCEntity->pev->skin, pCEntity->pev->sequence);
            pCMe->PrintTalk(tString);
		}
    }

    /*
    if(FStrEq(Cmd_Argv(0), "dome30"))
    {
    	//CBaseEntity *pCPlayer;
        //pCPlayer = CBaseEntity::Instance(pEntity);
        //pCPlayer->AddHealth(NULL, "pants", -30);
   		MESSAGE_BEGIN( MSG_ONE, REG_USER_MSG("Damage", 12), NULL, pEntity );
			WRITE_BYTE( 0 );
			WRITE_BYTE( 30 );
			WRITE_LONG( 1 );
			WRITE_COORD( pEntity->v.origin.x + RANDOM_LONG(0,256));
			WRITE_COORD( pEntity->v.origin.y + RANDOM_LONG(0,256));
			WRITE_COORD( pEntity->v.origin.z + RANDOM_LONG(0,256));
		MESSAGE_END();

    }
    */

    /*

    if(FStrEq(Cmd_Argv(0), "spawnandthink") && !FStrEq(Cmd_Argv(1), ""))
    {
    	edict_t *pTemp;
        static char classname[128];
        sprintf(classname, "%s", Cmd_Argv(1));
        pTemp = CREATE_NAMED_ENTITY(MAKE_STRING(classname));
        pTemp->v.origin = pEntity->v.origin;
        pTemp->v.angles = pEntity->v.angles;
        pTemp->v.velocity = Vector(0, 0, 0);
        DispatchSpawn(pTemp);
        pTemp->v.nextthink = gpGlobals->time;
        pTemp->v.classname = MAKE_STRING("info_target");
    }
    */

    /*
    // NOTE: It works! W00T!
    if(FStrEq(Cmd_Argv(0), "testsky"))
    {
    	TraceResult tr;
        UTIL_TraceLine(pEntity->v.origin, pEntity->v.origin + Vector(0,0,8192), ignore_monsters, pEntity, &tr);
        if(UTIL_PointContents(tr.vecEndPos) == CONTENTS_SKY)
        	ALERT(at_console, "> Under sky.\n");
        else
        	ALERT(at_console, "> Not under sky.\n");
    }
    */

    /*
    if(FStrEq(Cmd_Argv(0), "testweap"))
    {
		MESSAGE_BEGIN( MSG_ONE, REG_USER_MSG("CurWeapon", 3), NULL, pEntity );
			WRITE_BYTE( 0 );
			WRITE_BYTE( WEAPON_NONE );
			WRITE_BYTE( 99 );
		MESSAGE_END();
    }
    */

    if(FStrEq(Cmd_Argv(0), "togglegod") && (Features & FEAT_DEVMODE))
    {
    	if(pEntity->v.takedamage == DAMAGE_NO) pEntity->v.takedamage = DAMAGE_AIM;
        else
	        if(pEntity->v.takedamage != DAMAGE_NO) pEntity->v.takedamage = DAMAGE_NO;
    }

    if(FStrEq(Cmd_Argv(0), "toggleclip") && (Features & FEAT_DEVMODE))
    {
    	if(pEntity->v.movetype == MOVETYPE_NOCLIP) pEntity->v.movetype = MOVETYPE_WALK;
        else
	        if(pEntity->v.movetype != MOVETYPE_NOCLIP) pEntity->v.movetype = MOVETYPE_NOCLIP;
    }

    if(FStrEq(Cmd_Argv(0), "addarmor") && (Features & FEAT_DEVMODE))
    {
    	pEntity->v.armorvalue += 100;
    }

    /*
    if(FStrEq(Cmd_Argv(0), "buildteslacoil") && (Features & FEAT_DEVMODE) && Cmd_Argc()>1)
    {
    	NeoTFTeslaCoilBuild(pEntity, INDEXENT(atof(Cmd_Argv(1))));
    }

    if(FStrEq(Cmd_Argv(0), "buildgrenlaunch") && (Features & FEAT_DEVMODE) && Cmd_Argc()>1)
    {
    	NeoTFGrenLaunchBuild(pEntity, INDEXENT(atof(Cmd_Argv(1))));
    }

    if(FStrEq(Cmd_Argv(0), "buildrocklaunch") && (Features & FEAT_DEVMODE) && Cmd_Argc()>1)
    {
    	NeoTFRockLaunchBuild(pEntity, INDEXENT(atof(Cmd_Argv(1))));
    }
    */

    return 0;
}

int NeoTFClientPutInServer(edict_t *pEntity)
{
    EntTimes[ENTINDEX(pEntity)].LastGlyph = gpGlobals->time;
    EntTimes[ENTINDEX(pEntity)].LastRadar = gpGlobals->time;
    EntTimes[ENTINDEX(pEntity)].SpawnTime = gpGlobals->time;
    EntTimes[ENTINDEX(pEntity)].LastSayEnemy = gpGlobals->time;
    EntTimes[ENTINDEX(pEntity)].LastAquaJet = gpGlobals->time;
    EntTimes[ENTINDEX(pEntity)].LastLaserRocket = 0;
    EntTimes[ENTINDEX(pEntity)].DieTime = 0;
    EntTimes[ENTINDEX(pEntity)].EventTime = 0;

    EntInfo[ENTINDEX(pEntity)].Used.FlashGren = 0;
    EntInfo[ENTINDEX(pEntity)].Used.LaserRocket = 0;
    EntInfo[ENTINDEX(pEntity)].Used.AntiMissile = 0;
    EntInfo[ENTINDEX(pEntity)].Used.Multigun = 0;
    EntInfo[ENTINDEX(pEntity)].Primed.FlashGren = 0;
    EntInfo[ENTINDEX(pEntity)].DoneRespawnReset = 0;
    EntInfo[ENTINDEX(pEntity)].SelectedSG = NULL;
    EntInfo[ENTINDEX(pEntity)].SGCamOn = 0;
    EntInfo[ENTINDEX(pEntity)].AquaJetOn = 0;

	return 0;
}


int NeoTFDispatchSpawn(edict_t *pEntity)
{
	CBaseEntity *pCEntity;
	// Reset timers
    EntTimes[ENTINDEX(pEntity)].LastGlyph = gpGlobals->time;
    EntTimes[ENTINDEX(pEntity)].LastRadar = gpGlobals->time;
    EntTimes[ENTINDEX(pEntity)].SpawnTime = gpGlobals->time;
    EntTimes[ENTINDEX(pEntity)].LastSayEnemy = gpGlobals->time;
    EntTimes[ENTINDEX(pEntity)].LastAquaJet = gpGlobals->time;
    EntTimes[ENTINDEX(pEntity)].LastLaserRocket = 0;
    EntTimes[ENTINDEX(pEntity)].DieTime = 0;
    EntTimes[ENTINDEX(pEntity)].EventTime = 0;

    EntInfo[ENTINDEX(pEntity)].Used.FlashGren = 0;
    EntInfo[ENTINDEX(pEntity)].Used.LaserRocket = 0;
    EntInfo[ENTINDEX(pEntity)].Used.AntiMissile = 0;
    EntInfo[ENTINDEX(pEntity)].Used.Multigun = 0;
    EntInfo[ENTINDEX(pEntity)].Primed.FlashGren = 0;
    EntInfo[ENTINDEX(pEntity)].DoneRespawnReset = 0;
    EntInfo[ENTINDEX(pEntity)].SelectedSG = NULL;
    EntInfo[ENTINDEX(pEntity)].SGCamOn = 0;
    EntInfo[ENTINDEX(pEntity)].AquaJetOn = 0;

	// Check for worldspawn and precache stuff
	if (FStrEq(STRING(pEntity->v.classname), "worldspawn"))
	{
	    AirStrike[0].NextCallTime = gpGlobals->time;
	    AirStrike[1].NextCallTime = gpGlobals->time;
	    AirStrike[2].NextCallTime = gpGlobals->time;
	    AirStrike[3].NextCallTime = gpGlobals->time;

        NextCvarCheck = gpGlobals->time;

	    // See what extra features are enabled
	    Features = FEAT_NONE;
	    Features |= CVAR_GET_FLOAT("ntf_feature_spychat") ? FEAT_SPYCHAT : 0;
	    Features |= CVAR_GET_FLOAT("ntf_feature_radar") ? FEAT_RADAR : 0;
	    Features |= CVAR_GET_FLOAT("ntf_feature_glyphs") ? FEAT_GLYPHS : 0;
	    Features |= CVAR_GET_FLOAT("ntf_feature_flashgren") ? FEAT_FLASHGREN : 0;
        Features |= CVAR_GET_FLOAT("ntf_feature_noplayerscores") ? FEAT_NOPLAYERSCORES : 0;
        Features |= CVAR_GET_FLOAT("ntf_feature_sgcamera") ? FEAT_SGCAMERA : 0;
        Features |= CVAR_GET_FLOAT("ntf_feature_laserrocket") ? FEAT_LASERROCKET : 0;
        Features |= CVAR_GET_FLOAT("ntf_feature_aquaspy") ? FEAT_AQUASPY : 0;
        Features |= CVAR_GET_FLOAT("ntf_feature_antimissile") ? FEAT_ANTIMISSILE : 0;
        Features |= CVAR_GET_FLOAT("ntf_feature_devmode") ? FEAT_DEVMODE : 0;
        Features |= CVAR_GET_FLOAT("ntf_feature_multigun") ? FEAT_MULTIGUN : 0;
        Features |= CVAR_GET_FLOAT("ntf_feature_flamegun") ? FEAT_FLAMEGUN : 0;
        Features |= CVAR_GET_FLOAT("ntf_feature_teslacoil") ? FEAT_TESLACOIL : 0;
        Features |= CVAR_GET_FLOAT("ntf_feature_location") ? FEAT_LOCATION : 0;
        Features |= CVAR_GET_FLOAT("ntf_feature_meddisp") ? FEAT_MEDDISP : 0;
        Features |= CVAR_GET_FLOAT("ntf_feature_airstrike") ? FEAT_AIRSTRIKE : 0;
        Features |= CVAR_GET_FLOAT("ntf_feature_grenlaunch") ? FEAT_GRENLAUNCH : 0;
        Features |= CVAR_GET_FLOAT("ntf_feature_rocklaunch") ? FEAT_ROCKLAUNCH : 0;

        Features |= CVAR_GET_FLOAT("ntf_feature_sillyzone") ? FEAT_SILLYZONE : 0;
        Features |= CVAR_GET_FLOAT("ntf_feature_custommodels") ? FEAT_CUSTOMMODELS : 0;

   		precached_models[0] = PRECACHE_MODEL("sprites/laserbeam.spr"); // Beam effects sprite
   		precached_models[1] = PRECACHE_MODEL("models/invis.mdl"); // Ring of Shadows
   		precached_models[2] = PRECACHE_MODEL("models/quad.mdl"); // Quad damage
        precached_models[3] = PRECACHE_MODEL("sprites/lgtning.spr"); // Mortar lightning
        precached_models[4] = PRECACHE_MODEL ("sprites/bubble.spr"); // bubbles
        precached_models[5] = PRECACHE_MODEL ("models/w_battery.mdl"); // AntiMissile structure (until someone makes a model for it)
        precached_models[6] = PRECACHE_MODEL ("models/sentry.mdl"); // Multigun (until someone makes a model for it)
        precached_models[7] = PRECACHE_MODEL ("models/p_medkit.mdl"); // Medic dispenser add-on
        precached_models[8] = PRECACHE_MODEL ("sprites/fthrow.spr"); // Flamegun flame
        if(Features & FEAT_CUSTOMMODELS)
        {
	        precached_models[9] = PRECACHE_MODEL ("avatar-x/avadd44.avfil"); // sepp's tesla
	        precached_models[10] = PRECACHE_MODEL ("avatar-x/avadd45.avfil"); // sepp's rocket launcher
        }

        precached_sounds[0] = PRECACHE_SOUND("buttons/bell1.wav"); // Radar ping
        precached_sounds[1] = PRECACHE_SOUND("weapons/grenade_hit1.wav"); // Gren bounce
        precached_sounds[2] = PRECACHE_SOUND("weapons/grenade_hit2.wav"); // Gren bounce
        precached_sounds[3] = PRECACHE_SOUND("weapons/grenade_hit3.wav"); // Gren bounce
        precached_sounds[4] = PRECACHE_SOUND("debris/beamstart15.wav"); // Flash gren explode
        precached_sounds[5] = PRECACHE_SOUND("weapons/sgun1.wav"); // laserrocket launch
        precached_sounds[6] = PRECACHE_SOUND("doors/doormove2.wav"); // aquajet
        precached_sounds[7] = PRECACHE_SOUND("weapons/electro5.wav"); // Anti-missile-missile launch
        precached_sounds[8] = PRECACHE_SOUND("weapons/building.wav"); // Engineer building
        precached_sounds[9] = PRECACHE_SOUND("items/medshot4.wav"); // Dispenser heal
        precached_sounds[10] = PRECACHE_SOUND("weapons/flmfire2.wav"); // Flamegun fire
        precached_sounds[11] = PRECACHE_SOUND("ambience/particle_suck1.wav"); // Tesla charge
        precached_sounds[12] = PRECACHE_SOUND("debris/beamstart9.wav"); // Tesla zap 1
        precached_sounds[13] = PRECACHE_SOUND("debris/beamstart10.wav"); // Tesla zap 2
        precached_sounds[14] = PRECACHE_SOUND("debris/beamstart11.wav"); // Tesla zap 3
        precached_sounds[15] = PRECACHE_SOUND("weapons/mortar.wav"); // Airstrike launch
        precached_sounds[16] = PRECACHE_SOUND("weapons/glauncher.wav"); // Grenade launcher
        precached_sounds[17] = PRECACHE_SOUND("weapons/glauncher2.wav"); // Grenade launcher 2

        if(Features & FEAT_GLYPHS) NeoTFLoadGlyphs();
        if(Features & FEAT_LOCATION) NeoTFLoadBeacons();
    }
    return 0;
}

void NeoTFClientConnect( edict_t *pEntity, const char *pszName, const char *pszAddress, char szRejectReason[ 128 ]  )
{
}

void NeoTFSpyChat(edict_t *pEntity)
{
	CBaseEntity *pCEntity;
    char tString[8192];
    char mString[8192];
    int counter;
	if(Cmd_Argc()>1 && FStrEq(Cmd_Argv(0),"say_team") && !FStrEq(Cmd_Argv(1),""))
    {
    	pCEntity=NULL;
    	while(pCEntity = UTIL_FindEntityByClassname(pCEntity, "player"))
    	{
         	if(pCEntity->pev->playerclass==CLASS_SPY && pCEntity->pev->team!=pEntity->v.team && !(TeamAlly[pEntity->v.team-1] & (1<<pCEntity->pev->team)) && ((pEntity->v.origin - pCEntity->pev->origin).Length() < SPYCHAT_MAX_RANGE))
            {
                if(Cmd_Args()[0] == '\"')
	            	sprintf(mString, "%s", &Cmd_Args()[1]);
                else
	            	sprintf(mString, "%s", Cmd_Args());
                if(mString[strlen(mString)-1] == '\"')
	                mString[strlen(mString)-1] = '\0';
                for(counter=0;counter<strlen(mString);counter++)
                	{
                    if(RANDOM_LONG(0,(pEntity->v.origin - pCEntity->pev->origin).Length())>RANDOM_LONG(SPYCHAT_MAX_RANGE/4,SPYCHAT_MAX_RANGE))
                    	mString[counter]+=RANDOM_LONG(-10,10);
                    }
            	sprintf(tString, "(ENEMY) %s: %s\n", STRING(pEntity->v.netname), mString);
                pCEntity->PrintTalk(tString);
                // Let's try it with the new FakeSay functions -- hell, it might even give it some COLOUR! ;)
                // CBaseEntity *pCEntity = CBaseEntity::Instance(pEntity);
                // pCEntity->FakeSayToPlayer(pCEntity->edict(), mString);
            }
    	}
    }

    // Send fake teamchat messages
    // On second thoughts, this might be too evil so I'm removing it
    /*

    if((Cmd_Argc()>1) && FStrEq(Cmd_Argv(0), "say_enemy") && !FStrEq(Cmd_Argv(1),"") && (pEntity->v.playerclass==CLASS_SPY) && ((gpGlobals->time - EntTimes[ENTINDEX(pEntity)].LastSayEnemy) > 5))
    {
        char SayString[8192];
	    CBaseEntity *pTarget;
	    CBaseEntity *pClosest;
        CBaseEntity *pPlayer;
        pPlayer = CBaseEntity::Instance(pEntity);
	    pTarget = NULL;
        pClosest = NULL;
	    while(pTarget = UTIL_FindEntityByClassname(pTarget, "player"))
	    {
            if((pTarget->pev->team >= 1 && pTarget->pev->team <= 4) && (pTarget->pev->team != pEntity->v.team) && !(TeamAlly[pTarget->pev->team-1] & (1<<pEntity->v.team)))
            {
		        if(pClosest == NULL) pClosest = pTarget;
		        if((pTarget->pev->origin - pEntity->v.origin).Length() < (pClosest->pev->origin - pEntity->v.origin).Length()) pClosest = pTarget;
            }
	    }
        if(pClosest == NULL)
        {
        	pPlayer->PrintTalk("> Couldn't find a suitable player to use say_enemy with!\n");
            return;
        }
        pTarget = pClosest;

        sprintf(SayString, "say_team %s;", Cmd_Args());
        CLIENT_COMMAND(ENT(pTarget->pev), SayString);
        EntTimes[ENTINDEX(pEntity)].LastSayEnemy = gpGlobals->time;
    }
    */
}

void NeoTFRadar(edict_t *pEntity)
{
	CBaseEntity *pCEntity;
    int playercount = 0;
    int mechcount = 0;
    char text[1024];
    if((FStrEq(Cmd_Argv(0),"radar") || FStrEq(Cmd_Argv(0),"_special"))&& pEntity->v.playerclass==CLASS_SCOUT && (!pEntity->v.deadflag) && (gpGlobals->time - EntTimes[ENTINDEX(pEntity)].LastRadar > RADAR_INTERVAL))
    {
    	pCEntity=NULL;
        while(pCEntity = UTIL_FindEntityInSphere(pCEntity, pEntity->v.origin, RADAR_RANGE))
        {
        	if(FStrEq(STRING(pCEntity->pev->classname),"player") && ENTINDEX(ENT(pCEntity->pev))!=ENTINDEX(pEntity))
            {
            	pCEntity->PrivateBeamToEnt(pEntity, precached_models[0], 10, 10, Vector(0,255,0), 16+(((RADAR_RANGE - (pCEntity->pev->origin - pEntity->v.origin).Length())*192)/RADAR_RANGE));
                playercount++;
            }
        	if(FStrEq(STRING(pCEntity->pev->classname),"building_sentrygun") || FStrEq(STRING(pCEntity->pev->classname),"building_dispenser"))
            {
            	pCEntity->PrivateBeamToEnt(pEntity, precached_models[0], 10, 10, Vector(255,0,0), 16+(((RADAR_RANGE - (pCEntity->pev->origin - pEntity->v.origin).Length())*192)/RADAR_RANGE));
                mechcount++;
            }
        }
		EMIT_SOUND(pEntity, CHAN_VOICE, "buttons/bell1.wav", 1, ATTN_NORM);
        pCEntity = CBaseEntity::Instance(pEntity);
        sprintf(text, "> In range: %d players, %d mechanicals.\n", playercount, mechcount);
        pCEntity->PrintTalk(text);
		EntTimes[ENTINDEX(pEntity)].LastRadar = gpGlobals->time;
	}
}

void NeoTFGlyph(edict_t *pEntity)
{
	CBaseEntity *pCEntity;
    char tString[8192];
    int counter;
    int GlyphNumber = -1;
	if(Cmd_Argc()>1 && (FStrEq(Cmd_Argv(0),"glyph_team") || FStrEq(Cmd_Argv(0),"icon_team")) && (!pEntity->v.deadflag) && (gpGlobals->time - EntTimes[ENTINDEX(pEntity)].LastGlyph > GLYPH_INTERVAL))
    {
    	//Check if this glyph is valid
        for(counter=0;counter<GlyphCount;counter++)
        {
        	if(FStrEq(Glyph[counter].Name, Cmd_Argv(1)))
            	GlyphNumber = counter;
        }
        if(GlyphNumber != -1)
        {
	    	pCEntity=NULL;
	    	while(pCEntity = UTIL_FindEntityByClassname(pCEntity, "player"))
	    	{
	        	if(pCEntity->pev->team==pEntity->v.team || (TeamAlly[pEntity->v.team-1] & (1<<pCEntity->pev->team)))
	            {
					// byte (entity index of player)
					// coord (vertical offset) ( attachment origin.z = player origin.z + vertical offset )
					// short (model index)
					// short (life * 10 );
					MESSAGE_BEGIN(MSG_ONE, SVC_TEMPENTITY, NULL, ENT(pCEntity->pev));
						WRITE_BYTE(TE_PLAYERATTACHMENT);
	                    WRITE_BYTE(ENTINDEX(pEntity));
	                    WRITE_COORD(88);
	                    WRITE_SHORT(Glyph[GlyphNumber].SpriteIndex);
	                    WRITE_SHORT(GLYPH_TIME);
					MESSAGE_END();
	            }
	    	}
            EntTimes[ENTINDEX(pEntity)].LastGlyph = gpGlobals->time;
        }
    }


	if(Cmd_Argc()>1 && (FStrEq(Cmd_Argv(0),"glyph") || FStrEq(Cmd_Argv(0),"icon")) && (!pEntity->v.deadflag) && (gpGlobals->time - EntTimes[ENTINDEX(pEntity)].LastGlyph > GLYPH_INTERVAL))
    {
    	//Check if this glyph is valid
        for(counter=0;counter<GlyphCount;counter++)
        {
        	if(FStrEq(Glyph[counter].Name, Cmd_Argv(1)))
            	GlyphNumber = counter;
        }
        if(GlyphNumber != -1)
        {
	    	pCEntity=NULL;
	    	while(pCEntity = UTIL_FindEntityByClassname(pCEntity, "player"))
	    	{
				MESSAGE_BEGIN(MSG_ONE, SVC_TEMPENTITY, NULL, ENT(pCEntity->pev));
					WRITE_BYTE(TE_PLAYERATTACHMENT);
                    WRITE_BYTE(ENTINDEX(pEntity));
                    WRITE_COORD(88);
                    WRITE_SHORT(Glyph[GlyphNumber].SpriteIndex);
                    WRITE_SHORT(GLYPH_TIME);
				MESSAGE_END();
	    	}
            EntTimes[ENTINDEX(pEntity)].LastGlyph = gpGlobals->time;
        }
    }

   	if(Cmd_Argc()==1 && (FStrEq(Cmd_Argv(0),"glyph_list") || FStrEq(Cmd_Argv(0),"icon_list")))
    {
        pCEntity = CBaseEntity::Instance(pEntity);
    	for(counter=0;counter<GlyphCount;counter++)
        {
        	sprintf(tString, "> Glyph: %s\n", Glyph[counter].Name);
        	pCEntity->PrintConsole(tString);
        }
        sprintf(tString, "> %d glyphs.\n", GlyphCount);
        pCEntity->PrintConsole(tString);
    }
}

void NeoTFLoadGlyphs(void)
{
	FILE *glyphfile;
#ifndef __linux__
    glyphfile = fopen("tfc\\ntf_glyphs.txt","rt");
#else
    glyphfile = fopen("tfc/ntf_glyphs.txt","rt");
#endif
    if(glyphfile)
    	ALERT(at_console, "{NeoTF} File glyphs.txt found, loading glyphs.\n");
    else
    	ALERT(at_console, "{NeoTF} File glyphs.txt not found, not loading glyphs.\n");
    GlyphCount = 0;
    // Gotta keep the filename recorded in the array too because if the string is corrupted HL's model index gets all screwed.
    while(fscanf(glyphfile, "%s%s", Glyph[GlyphCount].Name, Glyph[GlyphCount].FileName)==2)
    {
    	Glyph[GlyphCount].SpriteIndex = PRECACHE_MODEL(Glyph[GlyphCount].FileName);
    	GlyphCount++;
    }
    fclose(glyphfile);
    ALERT(at_console, "{NeoTF} Loaded %d glyphs.\n", GlyphCount);
}

void NeoTFFlashGren(edict_t *pEntity)
{
	edict_t *pFlash;
 	if((FStrEq(Cmd_Argv(0), "+gren2") || FStrEq(Cmd_Argv(0), "primetwo")) && (!pEntity->v.deadflag) && (EntInfo[ENTINDEX(pEntity)].Used.FlashGren < FLASHGREN_AMMO) && (pEntity->v.playerclass == CLASS_SNIPER) && (!EntInfo[ENTINDEX(pEntity)].Primed.FlashGren))
    {
    	EntInfo[ENTINDEX(pEntity)].Primed.FlashGren = gpGlobals->time;
        EntInfo[ENTINDEX(pEntity)].Used.FlashGren++;
        MESSAGE_BEGIN(MSG_ONE, 79, NULL, pEntity);
			WRITE_BYTE(1);
			WRITE_CHAR(100);
			WRITE_CHAR(95);
			WRITE_STRING("concussiongrenade");
			WRITE_BYTE(255);
			WRITE_BYTE(160);
			WRITE_BYTE(0);
        MESSAGE_END();
        MESSAGE_BEGIN(MSG_ONE, 72, NULL, pEntity);
			WRITE_BYTE(1);
			WRITE_BYTE(FLASHGREN_AMMO - EntInfo[ENTINDEX(pEntity)].Used.FlashGren);
		MESSAGE_END();
    }
 	if((FStrEq(Cmd_Argv(0), "-gren2") || FStrEq(Cmd_Argv(0), "throwgren")) && (!pEntity->v.deadflag) && (pEntity->v.playerclass == CLASS_SNIPER) && (EntInfo[ENTINDEX(pEntity)].Primed.FlashGren))
    {
    	UTIL_MakeVectors(pEntity->v.v_angle);
    	pFlash = CREATE_NAMED_ENTITY(MAKE_STRING("info_target"));
    	DispatchSpawn(pFlash);
    	pFlash->v.origin = pEntity->v.origin;
    	pFlash->v.owner = pEntity;
    	pFlash->v.angles = Vector(0, pEntity->v.v_angle.y, 0);
    	pFlash->v.velocity = pEntity->v.velocity + gpGlobals->v_forward*400 + Vector(0, 0, 32);
        pFlash->v.takedamage = DAMAGE_NO;
        pFlash->v.health = 1;
        pFlash->v.movetype = MOVETYPE_BOUNCE;
        pFlash->v.nextthink = gpGlobals->time;
        // From ggrenade.cpp
       	// pGrenade->pev->gravity = 0.5;
		// pGrenade->pev->friction = 0.8;
        pFlash->v.gravity = 0.5;
        pFlash->v.friction = 0.8;
        pFlash->v.solid = SOLID_BBOX;
    	SET_MODEL(pFlash, "models/conc_grenade.mdl");
    	UTIL_SetSize(VARS(pFlash), Vector(0, 0, 0), Vector(0, 0, 0));
    	pFlash->v.classname = MAKE_STRING("ntf_flashgren");
        EntTimes[ENTINDEX(pFlash)].EventTime = EntInfo[ENTINDEX(pEntity)].Primed.FlashGren + 4;
        EntInfo[ENTINDEX(pEntity)].Primed.FlashGren = 0;
        MESSAGE_BEGIN(MSG_ONE, 79, NULL, pEntity);
			WRITE_BYTE(0);
			WRITE_CHAR(100);
			WRITE_CHAR(95);
			WRITE_STRING("concussiongrenade");
			WRITE_BYTE(255);
			WRITE_BYTE(160);
			WRITE_BYTE(0);
        MESSAGE_END();
    }
}

void NeoTFSGCamera(edict_t *pEntity)
{
	if(FStrEq(Cmd_Argv(0), "sgcam_switch"))
    {
    	int Next = NeoTFGetNextSG(pEntity);
        if(Next)
        	EntInfo[ENTINDEX(pEntity)].SelectedSG = Next;
        else
        	EntInfo[ENTINDEX(pEntity)].SelectedSG = NULL;

        if(EntInfo[ENTINDEX(pEntity)].SGCamOn && EntInfo[ENTINDEX(pEntity)].SelectedSG)
        {
        	NeoTFDeactivateRemoteCamera(pEntity);
        	NeoTFActivateRemoteCamera(pEntity, INDEXENT(EntInfo[ENTINDEX(pEntity)].SelectedSG));
        }
    }

    if(FStrEq(Cmd_Argv(0), "+sgcam") && !EntInfo[ENTINDEX(pEntity)].SGCamOn)
    {
    	edict_t *pSelected;
        pSelected = INDEXENT(EntInfo[ENTINDEX(pEntity)].SelectedSG);
    	if(pSelected && !pSelected->free)
        {
        	if(FStrEq(STRING(pSelected->v.classname), "building_sentrygun") && NeoTFGetSGTeam(pSelected)==pEntity->v.team)
            {
            	NeoTFDeactivateRemoteCamera(pEntity);
	        	NeoTFActivateRemoteCamera(pEntity, pSelected);
                EntInfo[ENTINDEX(pEntity)].SGCamOn = 1;
            }
            else
            {
            	EntInfo[ENTINDEX(pEntity)].SelectedSG = NeoTFGetNextSG(pEntity);
                pSelected = INDEXENT(EntInfo[ENTINDEX(pEntity)].SelectedSG);
                if(pSelected && !pSelected->free && FStrEq(STRING(pSelected->v.classname), "building_sentrygun") && NeoTFGetSGTeam(pSelected)==pEntity->v.team)
                {
                	NeoTFDeactivateRemoteCamera(pEntity);
		        	NeoTFActivateRemoteCamera(pEntity, pSelected);
	                EntInfo[ENTINDEX(pEntity)].SGCamOn = 1;
                }
            }
        }
        else
        {
	        EntInfo[ENTINDEX(pEntity)].SelectedSG = NeoTFGetNextSG(pEntity);
            pSelected = INDEXENT(EntInfo[ENTINDEX(pEntity)].SelectedSG);
            if(pSelected && !pSelected->free && FStrEq(STRING(pSelected->v.classname), "building_sentrygun") && NeoTFGetSGTeam(pSelected)==pEntity->v.team)
            {
            NeoTFDeactivateRemoteCamera(pEntity);
	       	NeoTFActivateRemoteCamera(pEntity, pSelected);
            EntInfo[ENTINDEX(pEntity)].SGCamOn = 1;
            }
        }
    }

    if(FStrEq(Cmd_Argv(0), "-sgcam") && EntInfo[ENTINDEX(pEntity)].SGCamOn)
    {
    	NeoTFDeactivateRemoteCamera(pEntity);
        EntInfo[ENTINDEX(pEntity)].SGCamOn = 0;
    }
}

int NeoTFGetSGTeam(edict_t *pEntity)
{
	// Thankyou, botman :)
    
	int ColourMap;

    ColourMap = pEntity->v.colormap;

    if(ColourMap == 0xA096)
    	return 1;
    if(ColourMap == 0x04FA)
    	return 2;
    if(ColourMap == 0x372D)
    	return 3;
    if(ColourMap == 0x6E64)
    	return 4;

   	//ALERT(at_console, "SG TEAM: UNKNOWN\n");
    return 0;
}

int NeoTFGetNextSG(edict_t *pEntity)
{
	edict_t *pSelected;
	CBaseEntity *pCSelected;
	pSelected = INDEXENT(EntInfo[ENTINDEX(pEntity)].SelectedSG);
	pCSelected = NULL;

	// Determine if current camera is valid
	if(pSelected && pSelected->free)
    {
    	pSelected = NULL;
    }

	pCSelected = CBaseEntity::Instance(pSelected);

	do
	{
    	//ALERT(at_console, "LOOKING FOR SG...\n");
		pCSelected = UTIL_FindEntityByClassname(pCSelected, "building_sentrygun");
	} while(pCSelected && NeoTFGetSGTeam(ENT(pCSelected->pev))!=pEntity->v.team);
	if(pCSelected) return ENTINDEX(ENT(pCSelected->pev));
    //ALERT(at_console, "FIRST PASS: NO SG FOUND!\n");
    // If above search returned NULL, try once more to loop back to the start
    if(!pCSelected)
    {
		do
		{
	    	//ALERT(at_console, "LOOKING FOR SG...\n");
			pCSelected = UTIL_FindEntityByClassname(pCSelected, "building_sentrygun");
		} while(pCSelected && NeoTFGetSGTeam(ENT(pCSelected->pev))!=pEntity->v.team);
    }
    if(pCSelected) return ENTINDEX(ENT(pCSelected->pev));
    //ALERT(at_console, "SECOND PASS: NO SG FOUND!\n");
  	return NULL;
}

void NeoTFActivateRemoteCamera(edict_t *pPlayer, edict_t *pEntity)
{
	//ALERT(at_console, "SPAWNING CAMERA\n");
	// Create a ntf_camera entity
    edict_t *pCamera;

    pCamera = CREATE_NAMED_ENTITY(MAKE_STRING("info_target"));
    DispatchSpawn(pCamera);
    pCamera->v.origin = pEntity->v.origin;
    if(FStrEq(STRING(pEntity->v.classname), "building_sentrygun"))
    	pCamera->v.origin = pCamera->v.origin + Vector(0, 0, 16);
    pCamera->v.angles = pEntity->v.angles;
    pCamera->v.velocity = pEntity->v.velocity;
    pCamera->v.takedamage = DAMAGE_NO;
    pCamera->v.solid = SOLID_NOT;
    pCamera->v.owner = pPlayer;
    pCamera->v.euser1 = pEntity;
    pCamera->v.movetype = MOVETYPE_NOCLIP;
    pCamera->v.classname = MAKE_STRING("ntf_camera");
    pCamera->v.nextthink = gpGlobals->time;
    pCamera->v.renderamt = 0;
    pCamera->v.rendermode = kRenderTransColor;
    pCamera->v.renderfx = kRenderFxNone;
   	SET_MODEL(pCamera, "models/nail.mdl");
    SET_VIEW(pPlayer, pCamera);
}

void NeoTFDeactivateRemoteCamera(edict_t *pPlayer)
{
	CBaseEntity *pCCamera;
    pCCamera = NULL;
    while(pCCamera = UTIL_FindEntityByClassname(pCCamera, "ntf_camera"))
    {
    	if(pCCamera->pev->owner == pPlayer)
        {
			//ALERT(at_console, "REMOVING CAMERA\n");
        	pCCamera->pev->flags |= FL_KILLME;
        }
    }
    SET_VIEW(pPlayer, pPlayer);
}

void NeoTFLaserRocket(edict_t *pEntity)
{
	if((FStrEq(Cmd_Argv(0), "laserrocket") || FStrEq(Cmd_Argv(0), "_special2")) && !pEntity->v.deadflag)
    {
    	CBaseEntity *pCLauncher;
        CBaseEntity *pCClosest;
        CBaseEntity *pCPlayer;
        CBaseEntity *pCTarget;
        TraceResult tr;
        bool foundlaser = 0;
        edict_t *pRocket;
        pCPlayer = CBaseEntity::Instance(pEntity);
        pCLauncher = NULL;
        pCClosest = NULL;
        pCTarget = NULL;
        // First find this sniper's dot
        while(!foundlaser && (pCTarget = UTIL_FindEntityByClassname(pCTarget, "laser_spot")))
        {
        	if(!FNullEnt(pCTarget->pev->owner) && (!pCTarget->pev->owner->free))
            {
            	if(pCTarget->pev->owner == pEntity)
                	foundlaser = 1;
            }
        }

        if(foundlaser == 0) return;

        while(pCLauncher = UTIL_FindEntityByClassname(pCLauncher, "ntf_amlauncher"))
        {
        	UTIL_TraceLine(pCTarget->pev->origin, pCLauncher->pev->origin, dont_ignore_monsters, pCTarget->edict(), &tr);
            if((tr.pHit == pCLauncher->edict()) && (EntInfo[ENTINDEX(pCLauncher->edict())].Used.LaserRocket < LASERROCKET_AMMO) && (gpGlobals->time - EntTimes[ENTINDEX(pCLauncher->edict())].LastLaserRocket > LASERROCKET_INTERVAL) && (pCLauncher->pev->team == pCPlayer->pev->team))
            {
            	if(pCClosest==NULL)
                	pCClosest = pCLauncher;
                else
                {
                	if((pCLauncher->pev->origin - pCPlayer->pev->origin).Length() < (pCClosest->pev->origin - pCPlayer->pev->origin).Length())
                    	pCClosest = pCLauncher;
                }
            }
        }

        pCLauncher = NULL;

        while(pCLauncher = UTIL_FindEntityByClassname(pCLauncher, "player"))
        {
        	UTIL_TraceLine(pCTarget->pev->origin, pCLauncher->pev->origin, dont_ignore_monsters, pCTarget->edict(), &tr);
            if((tr.pHit == pCLauncher->edict()) && (EntInfo[ENTINDEX(pCLauncher->edict())].Used.LaserRocket < LASERROCKET_AMMO) && (gpGlobals->time - EntTimes[ENTINDEX(pCLauncher->edict())].LastLaserRocket > LASERROCKET_INTERVAL) && (pCLauncher->pev->team == pCPlayer->pev->team) && ((pCLauncher->pev->playerclass == LASERROCKET_CLASS1) || (pCLauncher->pev->playerclass == LASERROCKET_CLASS2)) && (!pCLauncher->pev->deadflag))
            {
            	if(pCClosest==NULL)
                	pCClosest = pCLauncher;
                else
                {
                	if((pCLauncher->pev->origin - pCPlayer->pev->origin).Length() < (pCClosest->pev->origin - pCPlayer->pev->origin).Length())
                    	pCClosest = pCLauncher;
                }
            }
        }

        if(pCClosest == NULL) return;

        pCLauncher = pCClosest;

        EntInfo[ENTINDEX(pCLauncher->edict())].Used.LaserRocket++;
        EntTimes[ENTINDEX(pCLauncher->edict())].LastLaserRocket = gpGlobals->time;

		EMIT_SOUND(pCLauncher->edict(), CHAN_VOICE, "weapons/sgun1.wav", 1, ATTN_NORM);
       	pRocket = CREATE_NAMED_ENTITY(MAKE_STRING("tf_gl_grenade"));
        pRocket->v.origin = pCLauncher->pev->origin;
        pRocket->v.owner = pCPlayer->edict();
        DispatchSpawn(pRocket);
        pRocket->v.angles = Vector(90, 0, 0);
        pRocket->v.velocity = pCLauncher->pev->velocity + Vector(0, 0, 1024);
        pRocket->v.euser1 = pCTarget->edict();
        pRocket->v.classname = MAKE_STRING("ntf_laserrocket");
        pRocket->v.movetype = MOVETYPE_BOUNCEMISSILE;
        pRocket->v.nextthink = gpGlobals->time;
        pRocket->v.fuser1 = gpGlobals->time+15;
        pRocket->v.dmg = LASERROCKET_DAMAGE;
        pRocket->v.effects |= EF_LIGHT;

   		MESSAGE_BEGIN( MSG_BROADCAST, SVC_TEMPENTITY );

   		WRITE_BYTE( TE_BEAMFOLLOW );
		WRITE_SHORT( ENTINDEX(pRocket) );
		WRITE_SHORT( precached_models[0] );
		WRITE_BYTE( 40 ); // life
		WRITE_BYTE( 4 ); // width
		WRITE_BYTE( 255 ); // r
		WRITE_BYTE( 127 ); // g
		WRITE_BYTE( 0 ); // b
		WRITE_BYTE( 192 ); // brightness

        MESSAGE_END();
    }
}

void NeoTFAquaSpy(edict_t *pEntity)
{
	if(FStrEq(Cmd_Argv(0), "+aquajet"))
    {
    	if(gpGlobals->time - EntTimes[ENTINDEX(pEntity)].LastAquaJet > 2)
		 	EMIT_SOUND(pEntity, CHAN_ITEM, "doors/doormove2.wav", 1, ATTN_NORM);
    	EntInfo[ENTINDEX(pEntity)].AquaJetOn = 1;
	    EntTimes[ENTINDEX(pEntity)].LastAquaJet = gpGlobals->time;
	}
    if(FStrEq(Cmd_Argv(0), "-aquajet"))
    {
    	EntInfo[ENTINDEX(pEntity)].AquaJetOn = 0;
    }
}

void NeoTFAntiMissile(edict_t *pEntity)
{
	if(FStrEq(Cmd_Argv(0), "buildamlauncher") && (EntInfo[ENTINDEX(pEntity)].Used.AntiMissile < ANTIMISSILE_BUILDUSES) && !pEntity->v.deadflag)
    {
    	TraceResult tr;
        UTIL_MakeVectors(pEntity->v.v_angle);
        UTIL_TraceLine(pEntity->v.origin, pEntity->v.origin + Vector(gpGlobals->v_forward.x*32, gpGlobals->v_forward.y*32, 0), dont_ignore_monsters, pEntity, &tr);
        if(tr.flFraction==1.0)
        {
	    	if(pEntity->v.armorvalue >= ANTIMISSILE_REQUIREDARMOR)
	        {
	        	pEntity->v.armorvalue -= ANTIMISSILE_REQUIREDARMOR;
	 			EMIT_SOUND(pEntity, CHAN_ITEM, "weapons/building.wav", 1, ATTN_NORM);
	 	    	edict_t *pAM;
		        pAM = CREATE_NAMED_ENTITY(MAKE_STRING("info_target"));
		        DispatchSpawn(pAM);
		        pAM->v.origin = pEntity->v.origin;
		        pAM->v.angles = pEntity->v.v_angle;
		        pAM->v.angles.x = 0;
                pAM->v.angles.z = 0;
		        UTIL_MakeVectors(pEntity->v.v_angle);
		        pAM->v.velocity = pEntity->v.velocity * 0.5 + gpGlobals->v_forward * 256 + Vector(0,0,128);
		        pAM->v.euser1 = pEntity;
		        pAM->v.owner = pEntity;
		        pAM->v.takedamage = DAMAGE_YES;
		        pAM->v.health = 100000;
		        pAM->v.movetype = MOVETYPE_TOSS;
		        pAM->v.solid = SOLID_BBOX;
		        pAM->v.team = pEntity->v.team;
		        SET_MODEL(pAM, "models/w_battery.mdl");
				UTIL_SetSize(VARS(pAM), Vector(-16, -16, 0), Vector(16, 16, 16));
		        pAM->v.classname = MAKE_STRING("ntf_amlauncher");
		        pAM->v.nextthink = gpGlobals->time;
		        EntInfo[ENTINDEX(pEntity)].Used.AntiMissile++;
	        }
	        else
	        {
		        CBaseEntity *pCEntity;
		        pCEntity = CBaseEntity::Instance(pEntity);
		        pCEntity->PrintTalk("> You need 25 armor to build this.\n");
	        }
        }
        return;
    }

	if(FStrEq(Cmd_Argv(0), "buildamlauncher") && (EntInfo[ENTINDEX(pEntity)].Used.AntiMissile >= ANTIMISSILE_BUILDUSES) && !pEntity->v.deadflag)
    {
    	CBaseEntity *pCEntity;
        pCEntity = CBaseEntity::Instance(pEntity);
        pCEntity->PrintTalk("> You already have an anti-missile launcher.\n");
        return;
    }

    if(FStrEq(Cmd_Argv(0), "detamlauncher"))
    {
    	CBaseEntity *pCLauncher;
        edict_t *pBomb;
        pCLauncher = NULL;
        EntInfo[ENTINDEX(pEntity)].Used.AntiMissile = 0;
        while(pCLauncher = UTIL_FindEntityByClassname(pCLauncher, "ntf_amlauncher"))
        {
        	if(pCLauncher->pev->euser1 == pEntity)
            {
            	pCLauncher->pev->flags |= FL_KILLME;
                pBomb = CREATE_NAMED_ENTITY(MAKE_STRING("tf_gl_grenade"));
                DispatchSpawn(pBomb);
                pBomb->v.origin = pCLauncher->pev->origin;
                pBomb->v.velocity = Vector(0,0,0);
                pBomb->v.dmg = 100;
                pBomb->v.owner = pEntity;
                pBomb->v.effects |= EF_NODRAW;
                pBomb->v.nextthink = gpGlobals->time;
                pBomb->v.classname = MAKE_STRING("ntf_amlauncher_detonation");
            }
        }
        return;
    }
}

bool NeoTFAntiMissileLauncherThink(edict_t *pEntity)
{
	CBaseEntity *pCMissile;
    edict_t *pAMM;
    TraceResult tr;
    pCMissile = NULL;
    while(pCMissile = UTIL_FindEntityInSphere(pCMissile, pEntity->v.origin, ANTIMISSILE_RANGE))
    {
    	// Find any rockets in range
        if(!FNullEnt(pCMissile->pev->owner) && !ENT(pCMissile->pev)->free && !FNullEnt(pEntity->v.euser1))
        {
        UTIL_TraceLine(pEntity->v.origin, pCMissile->pev->origin, dont_ignore_monsters, pEntity, &tr);
    	if((FStrEq(STRING(pCMissile->pev->classname), "tf_rpg_rocket") || FStrEq(STRING(pCMissile->pev->classname), "tf_ic_rocket")) && (pCMissile->pev->owner->v.team != pEntity->v.team) && ((tr.vecEndPos-pCMissile->pev->origin).Length()<64))
        {
            if(!pCMissile->pev->iuser2)
            {
            	pCMissile->pev->iuser2 = 1;
				EMIT_SOUND(pEntity, CHAN_ITEM, "weapons/electro5.wav", 1, ATTN_NORM);
            	pAMM = CREATE_NAMED_ENTITY(MAKE_STRING("tf_gl_grenade"));
                DispatchSpawn(pAMM);
                pAMM->v.origin = pEntity->v.origin + Vector(0,0,4);
                pAMM->v.owner = pEntity->v.euser1;
                pAMM->v.angles = Vector(90,0,0);
                pAMM->v.velocity = Vector(0,0,512);
                pAMM->v.euser1 = ENT(pCMissile->pev);
                pAMM->v.movetype = MOVETYPE_BOUNCEMISSILE;
                pAMM->v.classname = MAKE_STRING("ntf_amm");
                pAMM->v.fuser1 = gpGlobals->time + 4;
                pAMM->v.nextthink = gpGlobals->time;
                pAMM->v.dmg = 5;
                pAMM->v.effects |= EF_LIGHT;

	       		MESSAGE_BEGIN( MSG_BROADCAST, SVC_TEMPENTITY );
					WRITE_BYTE( TE_BEAMFOLLOW );
					WRITE_SHORT( ENTINDEX(pAMM) );
					WRITE_SHORT( precached_models[0] );
					WRITE_BYTE( 10 ); // life
					WRITE_BYTE( 2 ); // width
					WRITE_BYTE( 255 ); // r
					WRITE_BYTE( 127 ); // g
					WRITE_BYTE( 0 ); // b
					WRITE_BYTE( 192 ); // brightness
	            MESSAGE_END();
            }
        }
        }
    }


    // Check to see that it isn't dead

    if(FNullEnt(pEntity->v.euser1) || pEntity->v.euser1->free || (pEntity->v.health <= (100000-ANTIMISSILE_HEALTH)) || (pEntity->v.team != pEntity->v.euser1->v.team) || (pEntity->v.euser1->v.playerclass!=CLASS_SNIPER))
    {
		edict_t *pBomb;
		if(EntInfo[ENTINDEX(pEntity->v.euser1)].Used.AntiMissile>0) EntInfo[ENTINDEX(pEntity->v.euser1)].Used.AntiMissile--;
		pBomb = CREATE_NAMED_ENTITY(MAKE_STRING("tf_gl_grenade"));
		DispatchSpawn(pBomb);
		pBomb->v.origin = pEntity->v.origin;
		pBomb->v.velocity = Vector(0,0,0);
		pBomb->v.dmg = 100;
		pBomb->v.owner = pEntity->v.euser1;
		pBomb->v.effects |= EF_NODRAW;
		pBomb->v.nextthink = gpGlobals->time;
		pBomb->v.classname = MAKE_STRING("ntf_amlauncher_detonation");
		pEntity->v.flags |= FL_KILLME;
    }

    if((pEntity->v.flags & FL_ONGROUND) && ((pEntity->v.origin - pEntity->v.euser1->v.origin).Length() > 32))
    {
    	pEntity->v.owner = NULL;
    }
    
    pEntity->v.nextthink = gpGlobals->time + 0.1;
    return 1;
}

bool NeoTFAMMThink(edict_t *pEntity)
{
	if(pEntity->v.euser1->free) return 0;
	if((pEntity->v.origin - pEntity->v.euser1->v.origin).Length() < 32)
    {
    	pEntity->v.euser1->v.flags |= FL_KILLME;
    	return 0;
    }
	pEntity->v.velocity = pEntity->v.velocity * 0.2 + (pEntity->v.euser1->v.origin - pEntity->v.origin).Normalize() * 1024;
	if(pEntity->v.velocity.Length() > 2000)
		pEntity->v.velocity = 2000 * pEntity->v.velocity.Normalize();
	pEntity->v.nextthink = gpGlobals->time + 0.05;
	if(pEntity->v.fuser1 < gpGlobals->time)
		return 0;
	else
		return 1;

}

void NeoTFMultigunBuild(edict_t *pEntity)
{
	if((FStrEq(Cmd_Argv(0), "buildmultigun") || FStrEq(Cmd_Argv(0), "_special2")) && (!pEntity->v.deadflag) && (EntInfo[ENTINDEX(pEntity)].Used.Multigun<1))
    {
     	TraceResult tr;
        UTIL_MakeVectors(pEntity->v.v_angle);
        UTIL_TraceLine(pEntity->v.origin, pEntity->v.origin + Vector(gpGlobals->v_forward.x*64, gpGlobals->v_forward.y*64, 0), dont_ignore_monsters, pEntity, &tr);
        if(tr.flFraction==1.0 && UTIL_CheckBox(tr.vecEndPos, Vector(32, 32, 64)))
        {
	    	if(pEntity->v.armorvalue >= MULTIGUN_REQUIREDARMOR)
	        {
	        	pEntity->v.armorvalue -= MULTIGUN_REQUIREDARMOR;
	 			EMIT_SOUND(pEntity, CHAN_ITEM, "weapons/building.wav", 1, ATTN_NORM);
	 	    	edict_t *pMultigun;
		        pMultigun = CREATE_NAMED_ENTITY(MAKE_STRING("info_target"));
		        DispatchSpawn(pMultigun);
		        pMultigun->v.origin = tr.vecEndPos; // - Vector(gpGlobals->v_forward.x*16, gpGlobals->v_forward.y*16, 0);
		        pMultigun->v.angles = pEntity->v.v_angle;
		        pMultigun->v.angles.x = 0;
                pMultigun->v.angles.z = 0;
                pMultigun->v.angles.y += 180; // Face the player
                if(pMultigun->v.angles.y >= 360) pMultigun->v.angles.z -= 360;
		        UTIL_MakeVectors(pEntity->v.v_angle);
		        pMultigun->v.velocity = Vector(0, 0, 0);
		        pMultigun->v.euser1 = pEntity;
		        //pMultigun->v.owner = pEntity;
		        pMultigun->v.takedamage = DAMAGE_YES;
		        pMultigun->v.health = 100000;
		        pMultigun->v.movetype = MOVETYPE_TOSS;
		        pMultigun->v.solid = SOLID_BBOX;
		        pMultigun->v.team = pEntity->v.team;
		        SET_MODEL(pMultigun, "models/sentry.mdl");
				UTIL_SetSize(VARS(pMultigun), Vector(-16, -16, 0), Vector(16, 16, 64));
		        pMultigun->v.classname = MAKE_STRING("ntf_multigun");
		        pMultigun->v.nextthink = gpGlobals->time;
		        EntInfo[ENTINDEX(pEntity)].Used.Multigun++;

                pMultigun->v.rendermode = kRenderTransAdd;
                pMultigun->v.renderfx = kRenderFxNone;
                pMultigun->v.renderamt = 128;
	        }
	        else
	        {
		        CBaseEntity *pCEntity;
		        pCEntity = CBaseEntity::Instance(pEntity);
		        pCEntity->PrintTalk("> You need 50 armor to build this.\n");
	        }
        }
        return;
	}

	if((FStrEq(Cmd_Argv(0), "buildmultigun") || FStrEq(Cmd_Argv(0), "_special2")) && (EntInfo[ENTINDEX(pEntity)].Used.Multigun >= 1) && !pEntity->v.deadflag)
    {
    	CBaseEntity *pCEntity;
        pCEntity = CBaseEntity::Instance(pEntity);
        pCEntity->PrintTalk("> You already have a multigun.\n");
        return;
    }

    if(FStrEq(Cmd_Argv(0), "detmultigun"))
    {
    	CBaseEntity *pCMultigun;
        edict_t *pBomb;
        pCMultigun = NULL;
        EntInfo[ENTINDEX(pEntity)].Used.Multigun = 0;
        while(pCMultigun = UTIL_FindEntityByClassname(pCMultigun, "ntf_multigun"))
        {
        	if(pCMultigun->pev->euser1 == pEntity)
            {
            	pCMultigun->pev->flags |= FL_KILLME;
                pBomb = CREATE_NAMED_ENTITY(MAKE_STRING("tf_gl_grenade"));
                DispatchSpawn(pBomb);
                pBomb->v.origin = pCMultigun->pev->origin;
                pBomb->v.velocity = Vector(0,0,0);
                pBomb->v.dmg = 100;
                pBomb->v.owner = pEntity;
                pBomb->v.effects |= EF_NODRAW;
                pBomb->v.nextthink = gpGlobals->time;
                pBomb->v.classname = MAKE_STRING("ntf_multigun_detonation");
                CBaseEntity *pCPlayer;
                pCPlayer = CBaseEntity::Instance(pEntity);
                pCPlayer->PrintTalk("> Your multigun was destroyed.\n");
            }
        }

        while(pCMultigun = UTIL_FindEntityByClassname(pCMultigun, "ntf_flamegun"))
        {
        	if(pCMultigun->pev->euser1 == pEntity)
            {
            	pCMultigun->pev->flags |= FL_KILLME;
                pBomb = CREATE_NAMED_ENTITY(MAKE_STRING("tf_gl_grenade"));
                DispatchSpawn(pBomb);
                pBomb->v.origin = pCMultigun->pev->origin;
                pBomb->v.velocity = Vector(0,0,0);
                pBomb->v.dmg = 100;
                pBomb->v.owner = pEntity;
                pBomb->v.effects |= EF_NODRAW;
                pBomb->v.nextthink = gpGlobals->time;
                pBomb->v.classname = MAKE_STRING("ntf_multigun_detonation");
                CBaseEntity *pCPlayer;
                pCPlayer = CBaseEntity::Instance(pEntity);
                pCPlayer->PrintTalk("> Your multigun was destroyed.\n");
            }
        }

        while(pCMultigun = UTIL_FindEntityByClassname(pCMultigun, "ntf_teslacoil"))
        {
        	if(pCMultigun->pev->euser1 == pEntity)
            {
            	pCMultigun->pev->flags |= FL_KILLME;
                pBomb = CREATE_NAMED_ENTITY(MAKE_STRING("tf_gl_grenade"));
                DispatchSpawn(pBomb);
                pBomb->v.origin = pCMultigun->pev->origin;
                pBomb->v.velocity = Vector(0,0,0);
                pBomb->v.dmg = 100;
                pBomb->v.owner = pEntity;
                pBomb->v.effects |= EF_NODRAW;
                pBomb->v.nextthink = gpGlobals->time;
                pBomb->v.classname = MAKE_STRING("ntf_multigun_detonation");
                CBaseEntity *pCPlayer;
                pCPlayer = CBaseEntity::Instance(pEntity);
                pCPlayer->PrintTalk("> Your multigun was destroyed.\n");
            }
        }

        while(pCMultigun = UTIL_FindEntityByClassname(pCMultigun, "ntf_grenlauncher"))
        {
        	if(pCMultigun->pev->euser1 == pEntity)
            {
            	pCMultigun->pev->flags |= FL_KILLME;
                pBomb = CREATE_NAMED_ENTITY(MAKE_STRING("tf_gl_grenade"));
                DispatchSpawn(pBomb);
                pBomb->v.origin = pCMultigun->pev->origin;
                pBomb->v.velocity = Vector(0,0,0);
                pBomb->v.dmg = 100;
                pBomb->v.owner = pEntity;
                pBomb->v.effects |= EF_NODRAW;
                pBomb->v.nextthink = gpGlobals->time;
                pBomb->v.classname = MAKE_STRING("ntf_multigun_detonation");
                CBaseEntity *pCPlayer;
                pCPlayer = CBaseEntity::Instance(pEntity);
                pCPlayer->PrintTalk("> Your multigun was destroyed.\n");
            }
        }
        while(pCMultigun = UTIL_FindEntityByClassname(pCMultigun, "ntf_rocklauncher"))
        {
        	if(pCMultigun->pev->euser1 == pEntity)
            {
            	pCMultigun->pev->flags |= FL_KILLME;
                pBomb = CREATE_NAMED_ENTITY(MAKE_STRING("tf_gl_grenade"));
                DispatchSpawn(pBomb);
                pBomb->v.origin = pCMultigun->pev->origin;
                pBomb->v.velocity = Vector(0,0,0);
                pBomb->v.dmg = 100;
                pBomb->v.owner = pEntity;
                pBomb->v.effects |= EF_NODRAW;
                pBomb->v.nextthink = gpGlobals->time;
                pBomb->v.classname = MAKE_STRING("ntf_multigun_detonation");
                CBaseEntity *pCPlayer;
                pCPlayer = CBaseEntity::Instance(pEntity);
                pCPlayer->PrintTalk("> Your multigun was destroyed.\n");
            }
        }

        while(pCMultigun = UTIL_FindEntityByClassname(pCMultigun, "ntf_lrlauncher"))
        {
        	if(pCMultigun->pev->euser1 == pEntity)
            {
            	pCMultigun->pev->flags |= FL_KILLME;
                pBomb = CREATE_NAMED_ENTITY(MAKE_STRING("tf_gl_grenade"));
                DispatchSpawn(pBomb);
                pBomb->v.origin = pCMultigun->pev->origin;
                pBomb->v.velocity = Vector(0,0,0);
                pBomb->v.dmg = 100;
                pBomb->v.owner = pEntity;
                pBomb->v.effects |= EF_NODRAW;
                pBomb->v.nextthink = gpGlobals->time;
                pBomb->v.classname = MAKE_STRING("ntf_multigun_detonation");
                CBaseEntity *pCPlayer;
                pCPlayer = CBaseEntity::Instance(pEntity);
                pCPlayer->PrintTalk("> Your multigun was destroyed.\n");
            }
        }

        return;
    }
}

bool NeoTFMultigunThink(edict_t *pEntity)
{
	// NOTE: As well as being used by multiguns, all guns derived from multiguns use this think code as well, after their standard think

	// Check it isn't dead
    if(FNullEnt(pEntity->v.euser1) || pEntity->v.euser1->free || (pEntity->v.health <= (100000-MULTIGUN_HEALTH)) || (pEntity->v.team != pEntity->v.euser1->v.team) || (pEntity->v.euser1->v.playerclass!=CLASS_ENGINEER))
    {
		edict_t *pBomb;
		if(EntInfo[ENTINDEX(pEntity->v.euser1)].Used.Multigun>0) EntInfo[ENTINDEX(pEntity->v.euser1)].Used.Multigun--;
		pBomb = CREATE_NAMED_ENTITY(MAKE_STRING("tf_gl_grenade"));
		DispatchSpawn(pBomb);
		pBomb->v.origin = pEntity->v.origin;
		pBomb->v.velocity = Vector(0,0,0);
		pBomb->v.dmg = 100;
		pBomb->v.owner = pEntity->v.euser1;
		pBomb->v.effects |= EF_NODRAW;
		pBomb->v.nextthink = gpGlobals->time;
		pBomb->v.classname = MAKE_STRING("ntf_multigun_detonation");
		pEntity->v.flags |= FL_KILLME;
        if(!FNullEnt(pEntity->v.euser1) && !pEntity->v.euser1->free)
        {
			CBaseEntity *pCPlayer;
			pCPlayer = CBaseEntity::Instance(pEntity->v.euser1);
			pCPlayer->PrintTalk("> Your multigun was destroyed.\n");
        }
    }

    pEntity->v.nextthink = gpGlobals->time + 0.1;

    return 1;
}

bool NeoTFLocation(edict_t *pEntity)
{
	// Search the say or say_team string for %l and replace with the player's location

    if((FStrEq(Cmd_Argv(0), "say") || FStrEq(Cmd_Argv(0), "say_team")) && (Cmd_Argc() >= 1))
    {
		static char *New_Args;
    	if(strstr(Cmd_Args(), "%l")) // display own location
        {
        	// Find the nearest beacon the player has LOS to
            CBaseEntity *pCPlayer = CBaseEntity::Instance(pEntity);
            TraceResult tr;
            int ClosestBeacon = -1;
            int ClosestRange = 8192; // So we don't have to keep calculating it
            int counter;
            char location[512];
            char buf[8192];
            for(counter = 0; counter<BeaconCount; counter++)
            {
            	// Perform range check first to cut down on the number of necessary tracelines
            	if((pCPlayer->pev->origin - Beacon[counter].origin).Length() < ClosestRange)
                {
            	UTIL_TraceLine(Beacon[counter].origin, pCPlayer->pev->origin, ignore_monsters, pCPlayer->edict(), &tr);
	                if((tr.vecEndPos - pCPlayer->pev->origin).Length() < 8)
	                {
                    	ClosestBeacon = counter;
                        ClosestRange = (pCPlayer->pev->origin - Beacon[counter].origin).Length();
	                }
                }
            }
            if(ClosestBeacon == -1)
            	sprintf(location, "unknown location");
            else
            	sprintf(location, "%s", Beacon[ClosestBeacon].name);
            New_Args = UTIL_StringSearchReplace("%l", location, Cmd_Args());

            // Client command = bad for some reason in SP but not in MP
            CLIENT_COMMAND(pEntity, "%s %s;", Cmd_Argv(0), New_Args);

             // Finally a way that works: it's very similar to botman's fake commands
             /*
             ModCmd.Argc = 2;
             if(FStrEq(Cmd_Argv(0), "say"))
             	sprintf(ModCmd.Argv1, "say");
             if(FStrEq(Cmd_Argv(0), "say_team"))
             	sprintf(ModCmd.Argv1, "say_team");
             sprintf(ModCmd.Argv2, "%s", New_Args);
             sprintf(ModCmd.Args, "%s", New_Args);
             // ALERT(at_console, "Modifying command (%d): %s %s\n", ModCmd.Argc, ModCmd.Argv1, ModCmd.Args);
             ModCmd.Modified = 1;

             // ClientCommand(pEntity);
             */
             return 1; // return 1 forces TFC to ignore this command
        }

    	if(strstr(Cmd_Args(), "%p")) // display location being looked at
        {
        	// Find the nearest beacon the player has LOS to
            CBaseEntity *pCPlayer = CBaseEntity::Instance(pEntity);
            TraceResult tr;
            Vector Target;
            int ClosestBeacon = -1;
            int ClosestRange = 8192; // So we don't have to keep calculating it
            int counter;
            char location[512];
            char buf[8192];
            static char *New_Args;
            UTIL_MakeVectors(pEntity->v.v_angle);
            UTIL_TraceLine((pEntity->v.origin + pEntity->v.view_ofs), (pEntity->v.origin + pEntity->v.view_ofs) + gpGlobals->v_forward * 8192, dont_ignore_monsters, pEntity, &tr);
            Target = tr.vecEndPos;
            for(counter = 0; counter<BeaconCount; counter++)
            {
            	// Perform range check first to cut down on the number of necessary tracelines
            	if((Target - Beacon[counter].origin).Length() < ClosestRange)
                {
            	UTIL_TraceLine(Beacon[counter].origin, Target, ignore_monsters, pCPlayer->edict(), &tr);
	                if((tr.vecEndPos - Target).Length() < 8)
	                {
                    	ClosestBeacon = counter;
                        ClosestRange = (Target - Beacon[counter].origin).Length();
	                }
                }
            }
            if(ClosestBeacon == -1)
            	sprintf(location, "unknown location");
            else
            	sprintf(location, "%s", Beacon[ClosestBeacon].name);
            New_Args = UTIL_StringSearchReplace("%p", location, Cmd_Args());

            CLIENT_COMMAND(pEntity, "%s %s;", Cmd_Argv(0), New_Args);
			/*
             ModCmd.Argc = 2;
             if(FStrEq(Cmd_Argv(0), "say"))
             	sprintf(ModCmd.Argv1, "say");
             if(FStrEq(Cmd_Argv(0), "say_team"))
             	sprintf(ModCmd.Argv1, "say_team");
             sprintf(ModCmd.Argv2, "%s", New_Args);
             sprintf(ModCmd.Args, "%s", New_Args);
             // ALERT(at_console, "Modifying command (%d): %s %s\n", ModCmd.Argc, ModCmd.Argv1, ModCmd.Args);
             ModCmd.Modified = 1;
        	*/

             // ClientCommand(pEntity);
             return 1; // return 1 forces TFC to ignore this CC
        }
        return 0;
    }

	if(FStrEq(Cmd_Argv(0), "beacon_add") && (Cmd_Argc() >= 2) && (Features & FEAT_DEVMODE))
    {
		FILE *fp;
	    char filename[256];
        char location[8192];
        char stemp[8192];
    #ifndef __linux__
        sprintf(filename, "tfc\\%s.nli", STRING(gpGlobals->mapname));
    #else
        sprintf(filename, "tfc/%s.nli", STRING(gpGlobals->mapname));
    #endif
        if(fp = fopen(filename, "at"))
        {
        	if(Cmd_Args()[0] == '\"')
            	sprintf(location, "%s", &Cmd_Args()[1]);
            else
            	sprintf(location, "%s", Cmd_Args());
            if(location[strlen(location)-1] == '\"')
            	location[strlen(location)-1] == '\0';
        	fprintf(fp, "[ %d %d %d %s ]\n", (int)pEntity->v.origin.x, (int)pEntity->v.origin.y, (int)pEntity->v.origin.z, location);
            fclose(fp);
            CBaseEntity *pCPlayer = CBaseEntity::Instance(pEntity);
            pCPlayer->PrintTalk("> Added a new location:\n");
            sprintf(stemp, "> %s\n", location);
            pCPlayer->PrintTalk(stemp);
            sprintf(Beacon[BeaconCount].name, "%s", location);
            Beacon[BeaconCount].origin.x = (int)pEntity->v.origin.x;
            Beacon[BeaconCount].origin.y = (int)pEntity->v.origin.y;
            Beacon[BeaconCount].origin.z = (int)pEntity->v.origin.z;
            BeaconCount++;
        }
        else
        {
	        ALERT(at_error, "{NeoTF} Couldn't open or create location file %s!\n", filename);
        }
        return 0;
    }

    if(FStrEq(Cmd_Argv(0), "beacon_show") && (Features & FEAT_DEVMODE))
    {
    	for(int counter = 0; counter < BeaconCount; counter++)
        {
        	Vector colour;
        	// Only show near beacons, or we'll reach the maximum beam limit and won't be able to draw them all
        	if((Beacon[counter].origin - pEntity->v.origin).Length() < 1024)
            {

            colour = Vector(255, 255, 255);
            if(strstr(Beacon[counter].name, "blue"))
            	colour = Vector(0, 0, 255);
            if(strstr(Beacon[counter].name, "red"))
            	colour = Vector(255, 0, 0);

        	MESSAGE_BEGIN(MSG_BROADCAST, SVC_TEMPENTITY);
            	WRITE_BYTE(TE_BEAMPOINTS);
                WRITE_COORD(Beacon[counter].origin.x);
                WRITE_COORD(Beacon[counter].origin.y);
                WRITE_COORD(Beacon[counter].origin.z-16);
                WRITE_COORD(Beacon[counter].origin.x);
                WRITE_COORD(Beacon[counter].origin.y);
                WRITE_COORD(Beacon[counter].origin.z+16);
                WRITE_SHORT(precached_models[0]);
                WRITE_BYTE(1);
                WRITE_BYTE(10);
                WRITE_BYTE(255);
                WRITE_BYTE(10);
                WRITE_BYTE(0);
                WRITE_BYTE(colour.x); WRITE_BYTE(colour.y); WRITE_BYTE(colour.z);
                WRITE_BYTE(255);
                WRITE_BYTE(1);
            MESSAGE_END();

        	MESSAGE_BEGIN(MSG_BROADCAST, SVC_TEMPENTITY);
            	WRITE_BYTE(TE_BEAMPOINTS);
                WRITE_COORD(Beacon[counter].origin.x);
                WRITE_COORD(Beacon[counter].origin.y-16);
                WRITE_COORD(Beacon[counter].origin.z);
                WRITE_COORD(Beacon[counter].origin.x);
                WRITE_COORD(Beacon[counter].origin.y+16);
                WRITE_COORD(Beacon[counter].origin.z);
                WRITE_SHORT(precached_models[0]);
                WRITE_BYTE(1);
                WRITE_BYTE(10);
                WRITE_BYTE(255);
                WRITE_BYTE(10);
                WRITE_BYTE(0);
                WRITE_BYTE(colour.x); WRITE_BYTE(colour.y); WRITE_BYTE(colour.z);
                WRITE_BYTE(255);
                WRITE_BYTE(1);
            MESSAGE_END();

        	MESSAGE_BEGIN(MSG_BROADCAST, SVC_TEMPENTITY);
            	WRITE_BYTE(TE_BEAMPOINTS);
                WRITE_COORD(Beacon[counter].origin.x-16);
                WRITE_COORD(Beacon[counter].origin.y);
                WRITE_COORD(Beacon[counter].origin.z);
                WRITE_COORD(Beacon[counter].origin.x+16);
                WRITE_COORD(Beacon[counter].origin.y);
                WRITE_COORD(Beacon[counter].origin.z);
                WRITE_SHORT(precached_models[0]);
                WRITE_BYTE(1);
                WRITE_BYTE(10);
                WRITE_BYTE(255);
                WRITE_BYTE(10);
                WRITE_BYTE(0);
                WRITE_BYTE(colour.x); WRITE_BYTE(colour.y); WRITE_BYTE(colour.z);
                WRITE_BYTE(255);
                WRITE_BYTE(1);
            MESSAGE_END();
            }
        }
        return 0;
    }

    if(FStrEq(Cmd_Argv(0), "beacon_list") && (Features & FEAT_DEVMODE))
    {
    	// Overflow ahoy!
    	CBaseEntity *pCPlayer = CBaseEntity::Instance(pEntity);
        char buf[8192];
    	for(int counter = 0; counter < BeaconCount; counter++)
        {
        	sprintf(buf, "> [ %d %d %d %s ]\n", (int)Beacon[counter].origin.x, (int)Beacon[counter].origin.y, (int)Beacon[counter].origin.z, Beacon[counter].name);
            pCPlayer->PrintTalk(buf);
        }
    }

    if(FStrEq(Cmd_Argv(0), "beacon_rotate_blue_to_red") && (Features & FEAT_DEVMODE))
    {
    	// Only really useful on maps that have odd (rotational) symmetry -- a version that works on maps like flagrun would be more difficult
        // because an axis of rotation would have to be specified
    	int newx;
        int newy;
        int newz;
        int i;
        bool FoundDuplicate;
        int NewBeaconCount = BeaconCount;
        FILE *fp;
        char filename[256];
        char *NewName;

    #ifndef __linux__
		sprintf(filename, "tfc\\%s.nli", STRING(gpGlobals->mapname));
    #else
		sprintf(filename, "tfc/%s.nli", STRING(gpGlobals->mapname));
    #endif
        if(fp = fopen(filename, "at"))
        {
	    	// Rotate all beacons 180 degrees around [0, 0, 0] and replace BLUE with RED in their names (ie. reverse signs of x and y coordinates)
	    	for(int counter = 0; counter < BeaconCount; counter++)
	        {
	        	newx = -Beacon[counter].origin.x;
	        	newy = -Beacon[counter].origin.y;
	        	newz = Beacon[counter].origin.z; // Don't mirror z coordinate
	        	// First, search through existing beacons and check that there isn't already one at this beacon's rotated position
	            FoundDuplicate = 0;
	            for(int i = 0; i < BeaconCount; i++)
	            	if((Beacon[i].origin.x == newx) && (Beacon[i].origin.y == newy) && (Beacon[i].origin.z = newz) && (i!=counter)) FoundDuplicate = 1;
	            if(!FoundDuplicate)
	            {
	            	NewBeaconCount++;
                    NewName = UTIL_StringSearchReplace("blue", "red", Beacon[counter].name);
	                sprintf(Beacon[NewBeaconCount].name, "%s", NewName);
	                Beacon[NewBeaconCount].origin = Vector(newx, newy, newz);
					fprintf(fp, "[ %d %d %d %s ]\n", (int)Beacon[NewBeaconCount].origin.x, (int)Beacon[NewBeaconCount].origin.y, (int)Beacon[NewBeaconCount].origin.z, Beacon[NewBeaconCount].name);
	            }
	        }
        }
        else
        {
        	ALERT(at_error, "{NeoTF} Couldn't open or create location file %s!\n", filename);
        }
        BeaconCount = NewBeaconCount;
        fclose(fp);
    }

    if(FStrEq(Cmd_Argv(0), "beacon_rotate_red_to_blue") && (Features & FEAT_DEVMODE))
    {
    	int newx;
        int newy;
        int newz;
        int i;
        bool FoundDuplicate;
        int NewBeaconCount = BeaconCount;
        FILE *fp;
        char filename[256];
        char *NewName;
    #ifndef __linux__
		sprintf(filename, "tfc\\%s.nli", STRING(gpGlobals->mapname));
    #else
		sprintf(filename, "tfc/%s.nli", STRING(gpGlobals->mapname));
    #endif
        if(fp = fopen(filename, "at"))
        {
	    	// Rotate all beacons 180 degrees around [0, 0, 0] and replace RED with BLUE in their names (ie. reverse signs of x and y coordinates)
	    	for(int counter = 0; counter < BeaconCount; counter++)
	        {
	        	newx = -Beacon[counter].origin.x;
	        	newy = -Beacon[counter].origin.y;
	        	newz = Beacon[counter].origin.z;
	        	// First, search through existing beacons and check that there isn't already one at this beacon's rotated position
	            FoundDuplicate = 0;
	            for(int i = 0; i < BeaconCount; i++)
	            	if((Beacon[i].origin.x == newx) && (Beacon[i].origin.y == newy) && (Beacon[i].origin.z = newz) && (i!=counter)) FoundDuplicate = 1;
	            if(!FoundDuplicate)
	            {
	            	NewBeaconCount++;
                    NewName = UTIL_StringSearchReplace("red", "blue", Beacon[counter].name);
	                sprintf(Beacon[NewBeaconCount].name, "%s", NewName);
	                Beacon[NewBeaconCount].origin = Vector(newx, newy, newz);
					fprintf(fp, "[ %d %d %d %s ]\n", (int)Beacon[NewBeaconCount].origin.x, (int)Beacon[NewBeaconCount].origin.y, (int)Beacon[NewBeaconCount].origin.z, Beacon[NewBeaconCount].name);
	            }
	        }
        }
        else
        {
        	ALERT(at_error, "{NeoTF} Couldn't open or create location file %s!\n", filename);
        }
        BeaconCount = NewBeaconCount;
        fclose(fp);
    }
    return 0;
}

void NeoTFLoadBeacons(void)
{
	FILE *fp;
    char filename[256];
    char location[512];
    char word[256];
    int CurrentBeacon = 0;
    int tx, ty, tz;

    BeaconCount = 0;
    #ifndef __linux__
		sprintf(filename, "tfc\\%s.nli", STRING(gpGlobals->mapname));
    #else
		sprintf(filename, "tfc/%s.nli", STRING(gpGlobals->mapname));
    #endif
    if(fp = fopen(filename, "rt"))
    {
    	while(fscanf(fp, "%s", word) != EOF)
        {
        	if(FStrEq(word, "["))
            {
            	sprintf(Beacon[CurrentBeacon].name, "\0");
            	fscanf(fp, "%d %d %d", &tx, &ty, &tz);
                Beacon[CurrentBeacon].origin.x = tx;
                Beacon[CurrentBeacon].origin.y = ty;
                Beacon[CurrentBeacon].origin.z = tz;
                do
                {
                	fscanf(fp, "%s", word);
                    if(!FStrEq(word, "]"))
                    {
                    	// /me doesn't trust strcat
                    	sprintf(location, "%s", Beacon[CurrentBeacon].name);
                        // Choose whether to start or append to the string
                        if(Beacon[CurrentBeacon].name[0]!='\0')
	                        sprintf(Beacon[CurrentBeacon].name, "%s %s", location, word);
                        else
	                        sprintf(Beacon[CurrentBeacon].name, "%s", word);

                        // ALERT(at_console, "%s\n", Beacon[CurrentBeacon].name);
                    }

                } while(!FStrEq(word, "]"));
                CurrentBeacon++;
                BeaconCount++;
            }
        }
    }
    else
    {
    	ALERT(at_console, "{NeoTF} No location information available on this map. See help to learn how to add locations.\n");
    }
    fclose(fp);
    ALERT(at_console, "{NeoTF} Loaded %d beacons.\n", BeaconCount);
}

void NeoTFMedDispBuild(edict_t *pPlayer, edict_t *pDispenser)
{
	// ALERT(at_console, "> Player %s used dispenser of index %d.\n", STRING(pPlayer->v.netname), ENTINDEX(pDispenser));
	if(pDispenser->v.euser1 != NULL) return;
    EMIT_SOUND(pDispenser, CHAN_ITEM, "weapons/building.wav", 1, ATTN_NORM);
	edict_t *pAddon;
    pAddon = CREATE_NAMED_ENTITY(MAKE_STRING("info_target"));
    DispatchSpawn(pAddon);
    pAddon->v.origin = pDispenser->v.origin + Vector(0, 0, 16);
    pAddon->v.owner = pPlayer;
    pAddon->v.solid = SOLID_NOT;
    pAddon->v.angles = Vector(0, 0, 0);
    pAddon->v.velocity = Vector(0, 0, 0);
    pAddon->v.movetype = MOVETYPE_NOCLIP;
    pAddon->v.euser1 = pDispenser; // Associated disp
    pAddon->v.fuser1 = gpGlobals->time; // Next recharge ping
    pDispenser->v.euser1 = pAddon; // Disp's associated meddisp
    SET_MODEL(pAddon, "models/p_medkit.mdl");
    pAddon->v.takedamage = DAMAGE_NO;
    pAddon->v.team = pPlayer->v.team;
    pAddon->v.classname = MAKE_STRING("ntf_meddisp");
    pAddon->v.nextthink = gpGlobals->time;
}

bool NeoTFMedDispThink(edict_t *pEntity)
{
	// Check disp is still around
    if(FNullEnt(pEntity->v.euser1) || pEntity->v.euser1->free)
    	pEntity->v.flags |= FL_KILLME;
        
	// Find any players in range
    CBaseEntity *pCPlayer = NULL;
    bool HealedOne = 0;

    if(gpGlobals->time > pEntity->v.fuser1)
    {
	    while(pCPlayer = UTIL_FindEntityInSphere(pCPlayer, pEntity->v.origin, MEDDISP_RANGE))
	    {
	    	if(FStrEq(STRING(pCPlayer->pev->classname), "player") && (pCPlayer->pev->team == pEntity->v.team) && (!pCPlayer->pev->deadflag))
	        {
	        	if(pCPlayer->pev->health < pCPlayer->pev->max_health)
	            {
                	HealedOne = 1;
	            	pCPlayer->pev->health+=(pCPlayer->pev->max_health < pCPlayer->pev->health + MEDDISP_HEAL) ? (pCPlayer->pev->max_health - pCPlayer->pev->health) : MEDDISP_HEAL;
	            }
	        }
	    }
        // If we healed at least one player
        if(HealedOne)
        {
        	// Sound
			EMIT_SOUND(pEntity, CHAN_ITEM, "items/medshot4.wav", 1, ATTN_NORM);

			MESSAGE_BEGIN( MSG_BROADCAST, SVC_TEMPENTITY );
				WRITE_BYTE( TE_BEAMTORUS );
				WRITE_COORD(pEntity->v.origin.x);
				WRITE_COORD(pEntity->v.origin.y);
				WRITE_COORD(pEntity->v.origin.z);
				WRITE_COORD(pEntity->v.origin.x);
				WRITE_COORD(pEntity->v.origin.y);
				WRITE_COORD(pEntity->v.origin.z + MEDDISP_RANGE);
				WRITE_SHORT(precached_models[0]);
				WRITE_BYTE( 0 ); // startframe
				WRITE_BYTE( 0 ); // framerate
				WRITE_BYTE( MEDDISP_INTERVAL * 5 ); // life
				WRITE_BYTE( 4 );  // width
				WRITE_BYTE( 0 );   // noise
				WRITE_BYTE( 255 );   // r, g, b
				WRITE_BYTE( 0 );   // r, g, b
				WRITE_BYTE( 0 );   // r, g, b
				WRITE_BYTE( 255 );	// brightness
				WRITE_BYTE( 0 );		// speed
			MESSAGE_END();
        }

        pEntity->v.fuser1 = gpGlobals->time + MEDDISP_INTERVAL;
    }

    pEntity->v.avelocity = Vector (0, 180/MEDDISP_INTERVAL, 0);

    pEntity->v.nextthink = gpGlobals->time + 0.1;
	return 1;
}

// NOTE: Flamethrower wasn't working, so it's disabled (can't upgrade multigun ot it)

void NeoTFFlamegunBuild(edict_t *pPlayer, edict_t *pMultigun)
{
	pMultigun->v.classname = MAKE_STRING("ntf_flamegun");
    pMultigun->v.fuser1 = gpGlobals->time; // Next time to fire
	EMIT_SOUND(pMultigun, CHAN_ITEM, "weapons/building.wav", 1, ATTN_NORM);
    pMultigun->v.nextthink = gpGlobals->time;
    CBaseEntity *pCTemp;
    pCTemp = CBaseEntity::Instance(pPlayer);
    pCTemp->PrintTalk("> You upgraded the multigun to a flamegun.\n");
    pCTemp = CBaseEntity::Instance(pMultigun->v.euser1);
    pCTemp->PrintTalk("> Your multigun was upgraded to a flamegun.\n");
	pMultigun->v.rendermode = kRenderNormal;
	pMultigun->v.renderfx = kRenderFxNone;
	pMultigun->v.renderamt = 255;
}

bool NeoTFFlamegunThink(edict_t *pEntity)
{
	CBaseEntity *pCClosest = NULL;
    int ClosestRange = 8192;
    CBaseEntity *pCEnemy = NULL;
    TraceResult tr;

	// Shoot at nearest player

    if(gpGlobals->time > pEntity->v.fuser1)
    {
	    while(pCEnemy = UTIL_FindEntityByClassname(pCEnemy, "player"))
        {
        	UTIL_TraceLine(pEntity->v.origin, pCEnemy->pev->origin, dont_ignore_monsters, pEntity, &tr);
            if((tr.pHit == pCEnemy->edict()) && ((pCEnemy->pev->origin - pEntity->v.origin).Length() < ClosestRange)  )// && (pEntity->v.team != pCEnemy->pev->team) && !(TeamAlly[pEntity->v.team-1] & (1<<pCEnemy->pev->team))))
            {
            	ClosestRange = (pCEnemy->pev->origin - pEntity->v.origin).Length();
                pCClosest = pCEnemy;
            }
        }

        if(pCClosest && (ClosestRange < FLAMEGUN_RANGE))
        {
        	edict_t *pFlames;
        	pCEnemy = pCClosest;
            pFlames = CREATE_NAMED_ENTITY(MAKE_STRING("tf_flamethrower_burst"));
            DispatchSpawn(pFlames);
            pFlames->v.origin = pEntity->v.origin + Vector(0,0,32) + (pCEnemy->pev->origin - (pEntity->v.origin + Vector(0,0,32))).Normalize() * 32;
            pFlames->v.velocity = (pCEnemy->pev->origin - (pEntity->v.origin + Vector(0,0,32))).Normalize() * 800;
            // pFlames->v.owner = pEntity->v.euser1;
            SET_MODEL(pFlames, "sprites/fthrow.spr");
            pFlames->v.effects &= ~EF_NODRAW;
            EMIT_SOUND(pEntity, CHAN_WEAPON, "weapons/flmfire2.wav", 1, ATTN_NORM);
            // pFlames->v.nextthink = gpGlobals->time + 0.1;

        }

        pEntity->v.fuser1 = gpGlobals->time + FLAMEGUN_INTERVAL;
    }

    NeoTFMultigunThink(pEntity); // Do all the standard things as well
    pEntity->v.nextthink = gpGlobals->time + 0.1; // its nexthink is handled by NeoTFMultigunThink
	return 1;
}

void NeoTFTeslaCoilBuild(edict_t *pPlayer, edict_t *pMultigun)
{
	pMultigun->v.classname = MAKE_STRING("ntf_teslacoil");
    pMultigun->v.fuser1 = gpGlobals->time; // Next time to fire
    pMultigun->v.fuser2 = 0; // Time spent charging
	EMIT_SOUND(pMultigun, CHAN_ITEM, "weapons/building.wav", 1, ATTN_NORM);
    pMultigun->v.nextthink = gpGlobals->time;
    CBaseEntity *pCTemp;
    pCTemp = CBaseEntity::Instance(pPlayer);
    pCTemp->PrintTalk("> You upgraded the multigun to a tesla coil.\n");
    pCTemp = CBaseEntity::Instance(pMultigun->v.euser1);
    pCTemp->PrintTalk("> Your multigun was upgraded to a tesla coil.\n");
	pMultigun->v.rendermode = kRenderNormal;
	pMultigun->v.renderfx = kRenderFxNone;
	pMultigun->v.renderamt = 255;
    if(Features & FEAT_CUSTOMMODELS)
    {
    	SET_MODEL(pMultigun, "avatar-x/avadd44.avfil");
		UTIL_SetSize(VARS(pMultigun), Vector(-16, -16, 0), Vector(16, 16, 64));
    }
}

bool NeoTFTeslaCoilThink(edict_t *pEntity)
{
	CBaseEntity *pCClosest = NULL;
    int ClosestRange = 8192;
    CBaseEntity *pCEnemy = NULL;
    TraceResult tr;

	// Shoot at nearest player

    if(gpGlobals->time > pEntity->v.fuser1)
    {
	    while(pCEnemy = UTIL_FindEntityByClassname(pCEnemy, "player"))
        {
        	UTIL_TraceLine(pEntity->v.origin + Vector(0,0,48), pCEnemy->pev->origin, dont_ignore_monsters, pEntity, &tr);
            if((tr.pHit == pCEnemy->edict()) && ((pCEnemy->pev->origin - pEntity->v.origin).Length() < ClosestRange) && (pEntity->v.team != pCEnemy->pev->team) && !(TeamAlly[pEntity->v.team-1] & (1<<pCEnemy->pev->team)))
            {
            	ClosestRange = (pCEnemy->pev->origin - pEntity->v.origin).Length();
                pCClosest = pCEnemy;
            }
        }

        if(pCClosest && (ClosestRange < TESLACOIL_RANGE))
        {
        	pCEnemy = pCClosest;
        	// Still need to charge?
            if(pEntity->v.fuser2 < TESLACOIL_CHARGETIME)
            {
            	if(pEntity->v.fuser2 <= 0.025)
                {
                	EMIT_SOUND(pEntity, CHAN_WEAPON, "ambience/particle_suck1.wav", 1, ATTN_NORM);
                }
				pEntity->v.renderfx = kRenderFxGlowShell;
                pEntity->v.renderamt = 128;
				pEntity->v.rendercolor = Vector((128*pEntity->v.fuser2)/TESLACOIL_CHARGETIME, (128*pEntity->v.fuser2)/TESLACOIL_CHARGETIME, (255*pEntity->v.fuser2)/TESLACOIL_CHARGETIME);
            	pEntity->v.fuser2+=0.1;
            }
            else
            {
            	if(RANDOM_LONG(0,5) > 1)
                {
	            	EMIT_SOUND(pEntity, CHAN_WEAPON, "debris/beamstart11.wav", 1, ATTN_NORM);
                }
                else
                {
                	if(RANDOM_LONG(0,1) == 1)
                    {
		            	EMIT_SOUND(pEntity, CHAN_WEAPON, "debris/beamstart10.wav", 1, ATTN_NORM);
                    }
                    else
                    {
		            	EMIT_SOUND(pEntity, CHAN_WEAPON, "debris/beamstart9.wav", 1, ATTN_NORM);
                    }
                }
            	pEntity->v.fuser2 = 0;
            	pEntity->v.fuser1 = gpGlobals->time + TESLACOIL_INTERVAL;
                pEntity->v.renderfx = kRenderFxNone;

	         	MESSAGE_BEGIN(MSG_BROADCAST, SVC_TEMPENTITY);
	            	WRITE_BYTE(TE_BEAMPOINTS);
	                WRITE_COORD(pEntity->v.origin.x);
	                WRITE_COORD(pEntity->v.origin.y);
	                WRITE_COORD(pEntity->v.origin.z+48);
	                WRITE_COORD(pCEnemy->pev->origin.x);
	                WRITE_COORD(pCEnemy->pev->origin.y);
	                WRITE_COORD(pCEnemy->pev->origin.z+32);
	                WRITE_SHORT(precached_models[3]);
	                WRITE_BYTE(1);
	                WRITE_BYTE(10);
	                WRITE_BYTE(5);
	                WRITE_BYTE(20);
	                WRITE_BYTE(64);
	                WRITE_BYTE(128); WRITE_BYTE(128); WRITE_BYTE(255);
	                WRITE_BYTE(255);
	                WRITE_BYTE(100);
	            MESSAGE_END();

	         	MESSAGE_BEGIN(MSG_BROADCAST, SVC_TEMPENTITY);
	            	WRITE_BYTE(TE_BEAMPOINTS);
	                WRITE_COORD(pEntity->v.origin.x);
	                WRITE_COORD(pEntity->v.origin.y);
	                WRITE_COORD(pEntity->v.origin.z+48);
	                WRITE_COORD(pCEnemy->pev->origin.x);
	                WRITE_COORD(pCEnemy->pev->origin.y);
	                WRITE_COORD(pCEnemy->pev->origin.z+32);
	                WRITE_SHORT(precached_models[3]);
	                WRITE_BYTE(1);
	                WRITE_BYTE(10);
	                WRITE_BYTE(5);
	                WRITE_BYTE(30);
	                WRITE_BYTE(64);
	                WRITE_BYTE(96); WRITE_BYTE(96); WRITE_BYTE(255);
	                WRITE_BYTE(255);
	                WRITE_BYTE(100);
	            MESSAGE_END();

	         	MESSAGE_BEGIN(MSG_BROADCAST, SVC_TEMPENTITY);
	            	WRITE_BYTE(TE_BEAMPOINTS);
	                WRITE_COORD(pEntity->v.origin.x);
	                WRITE_COORD(pEntity->v.origin.y);
	                WRITE_COORD(pEntity->v.origin.z+48);
	                WRITE_COORD(pCEnemy->pev->origin.x);
	                WRITE_COORD(pCEnemy->pev->origin.y);
	                WRITE_COORD(pCEnemy->pev->origin.z+32);
	                WRITE_SHORT(precached_models[3]);
	                WRITE_BYTE(1);
	                WRITE_BYTE(10);
	                WRITE_BYTE(5);
	                WRITE_BYTE(40);
	                WRITE_BYTE(96);
	                WRITE_BYTE(64); WRITE_BYTE(64); WRITE_BYTE(255);
	                WRITE_BYTE(255);
	                WRITE_BYTE(100);
	            MESSAGE_END();

	         	MESSAGE_BEGIN(MSG_BROADCAST, SVC_TEMPENTITY);
	            	WRITE_BYTE(TE_DLIGHT);
	                WRITE_COORD(pEntity->v.origin.x);
	                WRITE_COORD(pEntity->v.origin.y);
	                WRITE_COORD(pEntity->v.origin.z+48);
	                WRITE_BYTE(50);
	                WRITE_BYTE(64); WRITE_BYTE(64); WRITE_BYTE(255);
	                WRITE_BYTE(5);
	                WRITE_BYTE(1);
	            MESSAGE_END();

                edict_t *pBomb;
                pBomb = CREATE_NAMED_ENTITY(MAKE_STRING("tf_gl_grenade"));
                DispatchSpawn(pBomb);
                pBomb->v.origin = pCEnemy->pev->origin + Vector(0, 0, 32);
                pBomb->v.dmg = 200;
                pBomb->v.owner = pEntity->v.euser1;
                pBomb->v.classname = MAKE_STRING("ntf_teslacoil_strike");
                pBomb->v.effects |= EF_NODRAW;
                pBomb->v.nextthink = gpGlobals->time;
           }
        }
	    else
	    {
	    	// Discharge at 1/4 of charging speed
	    	if(pEntity->v.fuser2 > 0)
	        {
				pEntity->v.renderfx = kRenderFxGlowShell;
				pEntity->v.renderamt = 128;
				pEntity->v.rendercolor = Vector((128*pEntity->v.fuser2)/TESLACOIL_CHARGETIME, (128*pEntity->v.fuser2)/TESLACOIL_CHARGETIME, (255*pEntity->v.fuser2)/TESLACOIL_CHARGETIME);
	           	pEntity->v.fuser2-=0.025;
	        }
	        else
	        {
	        	pEntity->v.renderfx = kRenderFxNone;
	        }
	    }
    }

	NeoTFMultigunThink(pEntity);
    pEntity->v.nextthink = gpGlobals->time + 0.1;
	return 1;
}

void NeoTFCallAirStrike(edict_t *pPlayer)
{
	if((FStrEq(Cmd_Argv(0), "airstrike") || FStrEq(Cmd_Argv(0), "_special2")) && !pPlayer->v.deadflag)
    {
		CBaseEntity *pCPlayer;
	    TraceResult tr;
	    pCPlayer = CBaseEntity::Instance(pPlayer);
	    if(AirStrike[pPlayer->v.team-1].NextCallTime > gpGlobals->time)
	    	{
            	// This long text message may lag the server, I need an alternative
	        	char buf[1024];
	            sprintf(buf, "> Your team's airstrike will be ready for calling in %d seconds.\n", (int)(AirStrike[pPlayer->v.team-1].NextCallTime - gpGlobals->time));
	        	pCPlayer->PrintTalk(buf);
	        	return;
	        }
	    UTIL_MakeVectors(pPlayer->v.v_angle);
	    UTIL_TraceLine(pPlayer->v.origin + pPlayer->v.view_ofs, pPlayer->v.origin + pPlayer->v.view_ofs + gpGlobals->v_forward * 8192, ignore_monsters, pPlayer, &tr);
	    if(UTIL_PointContents(tr.vecEndPos) == CONTENTS_SKY)
    	{
	    	pCPlayer->PrintTalk("> Airstrike called.\n");
	    	edict_t *pStrike;
	    	AirStrike[pPlayer->v.team-1].NextCallTime = gpGlobals->time + AIRSTRIKE_INTERVAL;
	        pStrike = CREATE_NAMED_ENTITY(MAKE_STRING("info_target"));
	        DispatchSpawn(pStrike);
	        pStrike->v.origin = pPlayer->v.origin + Vector(0, 0, -32);
	        pStrike->v.effects |= EF_NODRAW;
	        pStrike->v.solid = SOLID_NOT;
	        pStrike->v.velocity = Vector(0, 0, 0);
	        pStrike->v.vuser1 = tr.vecEndPos;
	        pStrike->v.owner = pPlayer;
	        pStrike->v.iuser1 = 0;
	        pStrike->v.classname = MAKE_STRING("ntf_airstrike");
	        pStrike->v.nextthink = gpGlobals->time + AIRSTRIKE_CALLDELAY;
            EMIT_SOUND(pPlayer, CHAN_VOICE, "buttons/bell1.wav", 1, ATTN_NORM);

 			MESSAGE_BEGIN( MSG_BROADCAST, SVC_TEMPENTITY );
				WRITE_BYTE( TE_BEAMTORUS );
				WRITE_COORD(pPlayer->v.origin.x);
				WRITE_COORD(pPlayer->v.origin.y);
				WRITE_COORD(pPlayer->v.origin.z - 32);
				WRITE_COORD(pPlayer->v.origin.x);
				WRITE_COORD(pPlayer->v.origin.y);
				WRITE_COORD(pPlayer->v.origin.z + 128);
				WRITE_SHORT(precached_models[0]);
				WRITE_BYTE( 0 ); // startframe
				WRITE_BYTE( 0 ); // framerate
				WRITE_BYTE( 10 ); // life
				WRITE_BYTE( 2 );  // width
				WRITE_BYTE( 0 );   // noise
				WRITE_BYTE( 64 );   // r, g, b
				WRITE_BYTE( 255 );   // r, g, b
				WRITE_BYTE( 64 );   // r, g, b
				WRITE_BYTE( 128 );	// brightness
				WRITE_BYTE( 0 );		// speed
			MESSAGE_END();

         	MESSAGE_BEGIN(MSG_BROADCAST, SVC_TEMPENTITY);
            	WRITE_BYTE(TE_BEAMPOINTS);
                WRITE_COORD(pPlayer->v.origin.x);
                WRITE_COORD(pPlayer->v.origin.y);
                WRITE_COORD(pPlayer->v.origin.z-32);
                WRITE_COORD(pStrike->v.vuser1.x);
                WRITE_COORD(pStrike->v.vuser1.y);
                WRITE_COORD(pStrike->v.vuser1.z);
                WRITE_SHORT(precached_models[0]);
                WRITE_BYTE(1);
                WRITE_BYTE(0);
                WRITE_BYTE(10);
                WRITE_BYTE(20);
                WRITE_BYTE(0);
                WRITE_BYTE(64); WRITE_BYTE(255); WRITE_BYTE(64);
                WRITE_BYTE(255);
                WRITE_BYTE(0);
            MESSAGE_END();
	    }
	    else
	    {
	    	pCPlayer->PrintTalk("> You must be aiming at the sky to call an airstrike.\n");
	    }
    }
}

bool NeoTFAirStrikeThink(edict_t *pEntity)
{
	// If this is the first missile, play the incoming mortar sound
    if(pEntity->v.iuser1 == 0)
		EMIT_SOUND(pEntity, CHAN_ITEM, "weapons/mortar.wav", 1, ATTN_NORM);
	// Find a random location near the airstrike origin -- assumes skybox is flat
    pEntity->v.vuser2 = pEntity->v.vuser1 + Vector(RANDOM_LONG(-AIRSTRIKE_ORIGIN_SPREAD, AIRSTRIKE_ORIGIN_SPREAD), RANDOM_LONG(-AIRSTRIKE_ORIGIN_SPREAD, AIRSTRIKE_ORIGIN_SPREAD), 0);
    // Only launch this missile if it's spawning in the sky
    if(UTIL_PointContents(pEntity->v.vuser2) == CONTENTS_SKY)
    {
    	edict_t *pMissile;
        pMissile = CREATE_NAMED_ENTITY(MAKE_STRING("tf_gl_grenade"));
        DispatchSpawn(pMissile);
        pMissile->v.origin = pEntity->v.vuser2;
        pMissile->v.vuser1 = pEntity->v.origin - Vector(RANDOM_LONG(-AIRSTRIKE_TARGET_SPREAD, AIRSTRIKE_TARGET_SPREAD), RANDOM_LONG(-AIRSTRIKE_TARGET_SPREAD, AIRSTRIKE_TARGET_SPREAD), 0);
        pMissile->v.velocity = (pMissile->v.vuser1 - pMissile->v.origin).Normalize() * AIRSTRIKE_MISSILE_VELOCITY;
        pMissile->v.effects |= EF_LIGHT;
        pMissile->v.dmg = AIRSTRIKE_DAMAGE;
        pMissile->v.classname = MAKE_STRING("ntf_airstrike_missile");
        pMissile->v.movetype = MOVETYPE_NOCLIP;
        pMissile->v.owner = pEntity->v.owner;
        pMissile->v.nextthink = gpGlobals->time;
        // Safety check to remove missile if it's still around at this time
        pMissile->v.fuser1 = gpGlobals->time + 10;
        // Missile left the sky yet?
        pMissile->v.iuser1 = 0;

   		MESSAGE_BEGIN( MSG_BROADCAST, SVC_TEMPENTITY );
			WRITE_BYTE( TE_KILLBEAM );
            WRITE_SHORT( ENTINDEX(pMissile) );
        MESSAGE_END();

		EMIT_SOUND(pMissile, CHAN_WEAPON, "weapons/sgun1.wav", 1, ATTN_NORM);
    }
    pEntity->v.iuser1++;
    if(pEntity->v.iuser1 == AIRSTRIKE_STRIKES)
    {
    	pEntity->v.flags |= FL_KILLME;
    }
    pEntity->v.nextthink = gpGlobals->time + AIRSTRIKE_STRIKEDELAY;
	return 1;
}

bool NeoTFAirStrikeMissileThink(edict_t *pEntity)
{
	if(gpGlobals->time > pEntity->v.fuser1)
    	return 0;
	//if(((pEntity->v.origin - pEntity->v.vuser1).Length() < (AIRSTRIKE_MISSILE_VELOCITY*0.05)) || (pEntity->v.velocity.Length() < (AIRSTRIKE_MISSILE_VELOCITY*0.9)))
    //	return 0;
	if(pEntity->v.velocity.Length() < (AIRSTRIKE_MISSILE_VELOCITY*0.9))
    	return 0;
   	if(pEntity->v.iuser1 == 0)
	{
	    if(UTIL_PointContents(pEntity->v.origin) != CONTENTS_SKY)
	    {
		    	pEntity->v.movetype = MOVETYPE_FLY;
	      		MESSAGE_BEGIN( MSG_BROADCAST, SVC_TEMPENTITY );
					WRITE_BYTE( TE_BEAMFOLLOW );
					WRITE_SHORT( ENTINDEX(pEntity) );
					WRITE_SHORT( precached_models[0] );
					WRITE_BYTE( 10 ); // life
					WRITE_BYTE( 5 ); // width
					WRITE_BYTE( 255 ); // r
					WRITE_BYTE( 255 ); // g
					WRITE_BYTE( 255 ); // b
					WRITE_BYTE( 128 ); // brightness
				MESSAGE_END();
	            pEntity->v.iuser1 = 1;
        }
    }
	pEntity->v.nextthink = gpGlobals->time + 0.1;
    return 1;
}

void NeoTFGrenLaunchBuild(edict_t *pPlayer, edict_t *pMultigun)
{
	pMultigun->v.classname = MAKE_STRING("ntf_grenlauncher");
    pMultigun->v.fuser1 = gpGlobals->time; // Next time to fire
	EMIT_SOUND(pMultigun, CHAN_ITEM, "weapons/building.wav", 1, ATTN_NORM);
    pMultigun->v.nextthink = gpGlobals->time;
    CBaseEntity *pCTemp;
    pCTemp = CBaseEntity::Instance(pPlayer);
    pCTemp->PrintTalk("> You upgraded the multigun to a grenade launcher.\n");
    pCTemp = CBaseEntity::Instance(pMultigun->v.euser1);
    pCTemp->PrintTalk("> Your multigun was upgraded to a grenade launcher.\n");
	pMultigun->v.rendermode = kRenderNormal;
	pMultigun->v.renderfx = kRenderFxNone;
	pMultigun->v.renderamt = 255;
}

bool NeoTFGrenLaunchThink(edict_t *pEntity)
{
	CBaseEntity *pCClosest = NULL;
    int ClosestRange = 8192;
    CBaseEntity *pCEnemy = NULL;
    TraceResult tr;

	// Shoot at nearest player

    if(gpGlobals->time > pEntity->v.fuser1)
    {
	    while(pCEnemy = UTIL_FindEntityByClassname(pCEnemy, "player"))
        {
        	UTIL_TraceLine(pEntity->v.origin + Vector(0,0,48), pCEnemy->pev->origin, dont_ignore_monsters, pEntity, &tr);
            if((tr.pHit == pCEnemy->edict()) && ((pCEnemy->pev->origin - pEntity->v.origin).Length() < ClosestRange) && (pEntity->v.team != pCEnemy->pev->team) && !(TeamAlly[pEntity->v.team-1] & (1<<pCEnemy->pev->team)))
            {
            	ClosestRange = (pCEnemy->pev->origin - pEntity->v.origin).Length();
                pCClosest = pCEnemy;
            }
        }

        if(pCClosest && (ClosestRange < GRENLAUNCH_RANGE))
        {
        	float Theta = 30;
        	edict_t *pGren;
        	pCEnemy = pCClosest;

            pGren = CREATE_NAMED_ENTITY(MAKE_STRING("tf_gl_grenade"));
            DispatchSpawn(pGren);
            pGren->v.classname = MAKE_STRING("ntf_gl_grenade");
            pGren->v.origin = pEntity->v.origin + Vector(0,0,48);
            pGren->v.owner = pEntity;
            pGren->v.dmg = GRENLAUNCH_DAMAGE;

            pGren->v.angles = UTIL_VecToAngles(((pCEnemy->pev->origin + (pCEnemy->pev->velocity * GRENLAUNCH_PREDICT))- (pEntity->v.origin+Vector(0,0,48))).Normalize()) + Vector(-Theta, 0, 0);
            UTIL_MakeVectors(pGren->v.angles);
            pGren->v.velocity = gpGlobals->v_forward * UTIL_TossSpeedFromAngle(pEntity->v.origin+Vector(0,0,48), pCEnemy->pev->origin + (pCEnemy->pev->velocity * GRENLAUNCH_PREDICT), (Theta*M_PI)/180);
            if(RANDOM_LONG(0,1)==0)
	            EMIT_SOUND(pEntity, CHAN_WEAPON, "weapons/glauncher.wav", 1, ATTN_NORM);
            else
	            EMIT_SOUND(pEntity, CHAN_WEAPON, "weapons/glauncher2.wav", 1, ATTN_NORM);
            // ALERT(at_console, "> Gren firing: Speed %d, Angle %d.\n", (int)pGren->v.velocity.Length(), (int)pGren->v.angles.x);

      		MESSAGE_BEGIN( MSG_BROADCAST, SVC_TEMPENTITY );
				WRITE_BYTE( TE_BEAMFOLLOW );
				WRITE_SHORT( ENTINDEX(pGren) );
				WRITE_SHORT( precached_models[0] );
				WRITE_BYTE( 10 ); // life
				WRITE_BYTE( 5 ); // width
				WRITE_BYTE( 255 ); // r
				WRITE_BYTE( 255 ); // g
				WRITE_BYTE( 255 ); // b
				WRITE_BYTE( 64 ); // brightness
			MESSAGE_END();

            /*
         	MESSAGE_BEGIN(MSG_BROADCAST, SVC_TEMPENTITY);
            	WRITE_BYTE(TE_BEAMPOINTS);
                WRITE_COORD(pEntity->v.origin.x);
                WRITE_COORD(pEntity->v.origin.y);
                WRITE_COORD(pEntity->v.origin.z);
                WRITE_COORD(pCEnemy->pev->origin.x);
                WRITE_COORD(pCEnemy->pev->origin.y);
                WRITE_COORD(pCEnemy->pev->origin.z);
                WRITE_SHORT(precached_models[0]);
                WRITE_BYTE(1);
                WRITE_BYTE(0);
                WRITE_BYTE(10);
                WRITE_BYTE(20);
                WRITE_BYTE(0);
                WRITE_BYTE(64); WRITE_BYTE(255); WRITE_BYTE(64);
                WRITE_BYTE(255);
                WRITE_BYTE(0);
            MESSAGE_END();
            */

            pEntity->v.fuser1 = gpGlobals->time + GRENLAUNCH_INTERVAL;
        }

    }

	NeoTFMultigunThink(pEntity);
    pEntity->v.nextthink = gpGlobals->time + 0.1;
	return 1;
}

void NeoTFRockLaunchBuild(edict_t *pPlayer, edict_t *pMultigun)
{
	pMultigun->v.classname = MAKE_STRING("ntf_rocklauncher");
    pMultigun->v.fuser1 = gpGlobals->time; // Next time to fire
    pMultigun->v.iuser1 = 0; // Rockets in salvo used
	EMIT_SOUND(pMultigun, CHAN_ITEM, "weapons/building.wav", 1, ATTN_NORM);
    pMultigun->v.nextthink = gpGlobals->time;
    CBaseEntity *pCTemp;
    pCTemp = CBaseEntity::Instance(pPlayer);
    pCTemp->PrintTalk("> You upgraded the multigun to a rocket launcher.\n");
    pCTemp = CBaseEntity::Instance(pMultigun->v.euser1);
    pCTemp->PrintTalk("> Your multigun was upgraded to a rocket launcher.\n");
	pMultigun->v.rendermode = kRenderNormal;
	pMultigun->v.renderfx = kRenderFxNone;
	pMultigun->v.renderamt = 255;
    if(Features & FEAT_CUSTOMMODELS)
    {
    	SET_MODEL(pMultigun, "avatar-x/avadd45.avfil");
		UTIL_SetSize(VARS(pMultigun), Vector(-16, -16, 0), Vector(16, 16, 32));
    }
}

bool NeoTFRockLaunchThink(edict_t *pEntity)
{
	CBaseEntity *pCClosest = NULL;
    int ClosestRange = 8192;
    CBaseEntity *pCEnemy = NULL;
    TraceResult tr;

	// Shoot at nearest player

    if(gpGlobals->time > pEntity->v.fuser1)
    {
	    while(pCEnemy = UTIL_FindEntityByClassname(pCEnemy, "player"))
        {
        	UTIL_TraceLine(pEntity->v.origin + Vector(0,0,48), pCEnemy->pev->origin, dont_ignore_monsters, pEntity, &tr);
            if((tr.pHit == pCEnemy->edict()) && ((pCEnemy->pev->origin - pEntity->v.origin).Length() < ClosestRange) && (pEntity->v.team != pCEnemy->pev->team) && !(TeamAlly[pEntity->v.team-1] & (1<<pCEnemy->pev->team)))
            {
            	ClosestRange = (pCEnemy->pev->origin - pEntity->v.origin).Length();
                pCClosest = pCEnemy;
            }
        }

        if(pCClosest && (ClosestRange < ROCKLAUNCH_RANGE))
        {
        	edict_t *pRocket;
        	pCEnemy = pCClosest;
            Vector Offset;
            if(Features & FEAT_CUSTOMMODELS)
            	Offset = Vector(0,0,16);
            else
            	Offset = Vector(0,0,48);

            EMIT_SOUND(pEntity, CHAN_WEAPON, "weapons/sgun1.wav", 1, ATTN_NORM);
            pRocket = CREATE_NAMED_ENTITY(MAKE_STRING("tf_gl_grenade"));
            DispatchSpawn(pRocket);
            pRocket->v.classname = MAKE_STRING("ntf_rocket");
            pRocket->v.origin = pEntity->v.origin + Offset;
            UTIL_MakeVectors(pEntity->v.angles);
            if(Features * FEAT_CUSTOMMODELS)
	            pRocket->v.origin = pRocket->v.origin + ((pEntity->v.iuser1-1) * gpGlobals->v_right * 8);
            pRocket->v.owner = pEntity;
            pRocket->v.dmg = ROCKLAUNCH_DAMAGE;
            pRocket->v.velocity = ((pCEnemy->pev->origin + (pCEnemy->pev->velocity * ROCKLAUNCH_PREDICT)) - (pEntity->v.origin + Offset)).Normalize() * ROCKLAUNCH_VELOCITY;
            pRocket->v.angles = UTIL_VecToAngles(pRocket->v.velocity);
            pRocket->v.effects |= EF_LIGHT;
            pRocket->v.movetype = MOVETYPE_FLY;
            pRocket->v.nextthink = gpGlobals->time + 10;

            pEntity->v.controller[0] = ((pRocket->v.angles.y - pEntity->v.angles.y)*256)/360;

       		MESSAGE_BEGIN( MSG_BROADCAST, SVC_TEMPENTITY );
				WRITE_BYTE( TE_BEAMFOLLOW );
				WRITE_SHORT( ENTINDEX(pRocket) );
				WRITE_SHORT( precached_models[0] );
				WRITE_BYTE( 10 ); // life
				WRITE_BYTE( 2 ); // width
				WRITE_BYTE( 255 ); // r
				WRITE_BYTE( 255 ); // g
				WRITE_BYTE( 255 ); // b
				WRITE_BYTE( 128 ); // brightness
			MESSAGE_END();

            /*
         	MESSAGE_BEGIN(MSG_BROADCAST, SVC_TEMPENTITY);
            	WRITE_BYTE(TE_BEAMPOINTS);
                WRITE_COORD(pEntity->v.origin.x);
                WRITE_COORD(pEntity->v.origin.y);
                WRITE_COORD(pEntity->v.origin.z);
                WRITE_COORD(pCEnemy->pev->origin.x);
                WRITE_COORD(pCEnemy->pev->origin.y);
                WRITE_COORD(pCEnemy->pev->origin.z);
                WRITE_SHORT(precached_models[0]);
                WRITE_BYTE(1);
                WRITE_BYTE(0);
                WRITE_BYTE(10);
                WRITE_BYTE(20);
                WRITE_BYTE(0);
                WRITE_BYTE(64); WRITE_BYTE(255); WRITE_BYTE(64);
                WRITE_BYTE(255);
                WRITE_BYTE(0);
            MESSAGE_END();

         	MESSAGE_BEGIN(MSG_BROADCAST, SVC_TEMPENTITY);
            	WRITE_BYTE(TE_BEAMPOINTS);
                WRITE_COORD(pEntity->v.origin.x);
                WRITE_COORD(pEntity->v.origin.y);
                WRITE_COORD(pEntity->v.origin.z);
                WRITE_COORD(pEntity->v.origin.x + pRocket->v.velocity.x);
                WRITE_COORD(pEntity->v.origin.y + pRocket->v.velocity.y);
                WRITE_COORD(pEntity->v.origin.z + pRocket->v.velocity.z);
                WRITE_SHORT(precached_models[0]);
                WRITE_BYTE(1);
                WRITE_BYTE(0);
                WRITE_BYTE(10);
                WRITE_BYTE(20);
                WRITE_BYTE(0);
                WRITE_BYTE(255); WRITE_BYTE(64); WRITE_BYTE(64);
                WRITE_BYTE(255);
                WRITE_BYTE(0);
            MESSAGE_END();
            */

            pEntity->v.iuser1++;
            if(pEntity->v.iuser1 < ROCKLAUNCH_BURST_COUNT)
            {
            	pEntity->v.fuser1 = gpGlobals->time + ROCKLAUNCH_BURST_INTERVAL;
            }
            else
            {
            	pEntity->v.fuser1 = gpGlobals->time + ROCKLAUNCH_INTERVAL;
                pEntity->v.iuser1 = 0;
            }
       }
    }


	NeoTFMultigunThink(pEntity);
    pEntity->v.nextthink = gpGlobals->time + 0.1;
	return 1;
}


int NeoTFStartFrame(void)
{
	if(gpGlobals->time > NextCvarCheck)
    {
    	int OldFeatures = Features;
    	Features = FEAT_NONE;
        if(OldFeatures & FEAT_SILLYZONE) Features |= FEAT_SILLYZONE;
        if(OldFeatures & FEAT_CUSTOMMODELS) Features |= FEAT_CUSTOMMODELS;
        if(OldFeatures & FEAT_GLYPHS) Features |= FEAT_GLYPHS;
	    Features |= CVAR_GET_FLOAT("ntf_feature_spychat") ? FEAT_SPYCHAT : 0;
	    Features |= CVAR_GET_FLOAT("ntf_feature_radar") ? FEAT_RADAR : 0;
	    Features |= CVAR_GET_FLOAT("ntf_feature_flashgren") ? FEAT_FLASHGREN : 0;
        Features |= CVAR_GET_FLOAT("ntf_feature_noplayerscores") ? FEAT_NOPLAYERSCORES : 0;
        Features |= CVAR_GET_FLOAT("ntf_feature_sgcamera") ? FEAT_SGCAMERA : 0;
        Features |= CVAR_GET_FLOAT("ntf_feature_laserrocket") ? FEAT_LASERROCKET : 0;
        Features |= CVAR_GET_FLOAT("ntf_feature_aquaspy") ? FEAT_AQUASPY : 0;
        Features |= CVAR_GET_FLOAT("ntf_feature_antimissile") ? FEAT_ANTIMISSILE : 0;
        Features |= CVAR_GET_FLOAT("ntf_feature_devmode") ? FEAT_DEVMODE : 0;
        Features |= CVAR_GET_FLOAT("ntf_feature_multigun") ? FEAT_MULTIGUN : 0;
        Features |= CVAR_GET_FLOAT("ntf_feature_flamegun") ? FEAT_FLAMEGUN : 0;
        Features |= CVAR_GET_FLOAT("ntf_feature_teslacoil") ? FEAT_TESLACOIL : 0;
        Features |= CVAR_GET_FLOAT("ntf_feature_location") ? FEAT_LOCATION : 0;
        Features |= CVAR_GET_FLOAT("ntf_feature_meddisp") ? FEAT_MEDDISP : 0;
        Features |= CVAR_GET_FLOAT("ntf_feature_airstrike") ? FEAT_AIRSTRIKE : 0;
        Features |= CVAR_GET_FLOAT("ntf_feature_grenlaunch") ? FEAT_GRENLAUNCH : 0;
        Features |= CVAR_GET_FLOAT("ntf_feature_rocklaunch") ? FEAT_ROCKLAUNCH : 0;

    	NextCvarCheck = gpGlobals->time + 10;
    }
	return 0;
}

bool NeoTFLRLaunchBuild(edict_t *pPlayer, edict_t *pMultigun)
{
	pMultigun->v.classname = MAKE_STRING("ntf_lrlauncher");
    pMultigun->v.fuser1 = gpGlobals->time; // Next time to fire
	EMIT_SOUND(pMultigun, CHAN_ITEM, "weapons/building.wav", 1, ATTN_NORM);
    pMultigun->v.nextthink = gpGlobals->time;
    CBaseEntity *pCTemp;
    pCTemp = CBaseEntity::Instance(pPlayer);
    pCTemp->PrintTalk("> You upgraded the multigun to a laser-guided rocket launcher.\n");
    pCTemp = CBaseEntity::Instance(pMultigun->v.euser1);
    pCTemp->PrintTalk("> Your multigun was upgraded to a laser-guided rocket launcher.\n");
	pMultigun->v.rendermode = kRenderNormal;
	pMultigun->v.renderfx = kRenderFxNone;
	pMultigun->v.renderamt = 255;
}

bool NeoTFLRLaunchThink(edict_t *pEntity)
{
	CBaseEntity *pCClosest = NULL;
    int ClosestRange = 8192;
    CBaseEntity *pCEnemy = NULL;
    TraceResult tr;

	// Shoot at nearest player

    if(gpGlobals->time > pEntity->v.fuser1)
    {
	    while(pCEnemy = UTIL_FindEntityByClassname(pCEnemy, "player"))
        {
        	UTIL_TraceLine(pEntity->v.origin + Vector(0,0,48), pCEnemy->pev->origin, dont_ignore_monsters, pEntity, &tr);
            if((tr.pHit == pCEnemy->edict()) && ((pCEnemy->pev->origin - pEntity->v.origin).Length() < ClosestRange) && (pEntity->v.team != pCEnemy->pev->team) && !(TeamAlly[pEntity->v.team-1] & (1<<pCEnemy->pev->team)))
            {
            	ClosestRange = (pCEnemy->pev->origin - pEntity->v.origin).Length();
                pCClosest = pCEnemy;
            }
        }

        if(pCClosest && (ClosestRange < LRLAUNCH_RANGE))
        {
        	edict_t *pRocket;
        	pCEnemy = pCClosest;

			EMIT_SOUND(pEntity, CHAN_VOICE, "weapons/sgun1.wav", 1, ATTN_NORM);
	       	pRocket = CREATE_NAMED_ENTITY(MAKE_STRING("tf_gl_grenade"));
	        pRocket->v.origin = pEntity->v.origin;
	        pRocket->v.owner = pEntity->v.owner;
	        DispatchSpawn(pRocket);
	        pRocket->v.angles = Vector(90, 0, 0);
	        pRocket->v.velocity = pEntity->v.velocity + Vector(0, 0, 1024);
	        pRocket->v.euser1 = pCEnemy->edict();
	        pRocket->v.classname = MAKE_STRING("ntf_laserrocket");
	        pRocket->v.movetype = MOVETYPE_BOUNCEMISSILE;
	        pRocket->v.nextthink = gpGlobals->time;
	        pRocket->v.fuser1 = gpGlobals->time+15;
	        pRocket->v.dmg = LRLAUNCH_DAMAGE;
	        pRocket->v.effects |= EF_LIGHT;

	   		MESSAGE_BEGIN( MSG_BROADCAST, SVC_TEMPENTITY );

	   		WRITE_BYTE( TE_BEAMFOLLOW );
			WRITE_SHORT( ENTINDEX(pRocket) );
			WRITE_SHORT( precached_models[0] );
			WRITE_BYTE( 40 ); // life
			WRITE_BYTE( 4 ); // width
			WRITE_BYTE( 255 ); // r
			WRITE_BYTE( 127 ); // g
			WRITE_BYTE( 0 ); // b
			WRITE_BYTE( 192 ); // brightness

	        MESSAGE_END();

            pEntity->v.fuser1 = gpGlobals->time + LRLAUNCH_INTERVAL;
        }
    }

	NeoTFMultigunThink(pEntity);
    pEntity->v.nextthink = gpGlobals->time + 0.1;
	return 1;
}
